#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <sm_client.h>
#include "mood_catdef.h"
#include "mood_error.h"
#include "mood_DBrecord.h"
#include "timer.h"


VOLID 		VolumeId ;
TID   		TransactionId;
int   		BufferGroup;
FID   		FileIdentifier, DBFile, CatalogID, UnsizedFID;
IID		RefIID;
OBJHDR 		ObjectHeader;
FILE  		*ErrStrm;
MoodsError	catalogError;
struct DBrecord DBrec;
extern FILE  	*sm_ErrorStream;
int		noDBInUse;
char		*MoodHome;
char		*MoodBin;
char		DatabaseHome[2*MAXSTRLEN];
Timer           moodTimer;
FILE		*myalloc = NULL;
FILE		*dealloc = NULL;
int		interfaceMode;

char *myAlloc( int size )
{
        char *buf;
        buf = (char *) malloc( size );
/*
        myalloc = fopen( "allocate.dat", "a" );
        fprintf( myalloc, "%p char-%d\n", buf, size );
        fclose( myalloc );
*/
        return buf;
}

myFree( char *buf )
{
	if( !buf ) return 1;
/*
        dealloc = fopen( "deallocate.dat", "a" );
        fprintf( dealloc, "%p char\n", buf );
        fclose( dealloc );
*/
        free( buf );
	return 1;
}


displayFID( FID *fid )
{
	int i;
	char	*p ;
	p = (char *) fid;
	printf(" FID : ");
	for( i =0; i<sizeof(FID); i++)
		printf("%x  ", p[i] );
	printf("%%%%%%\n");
	return 1;
}

int Test_Oid( OID Pfirst , OID Psecond , int Pcondition )
{
	int status1=0,status2=0;

	if ( Pfirst.diskAddr.volid < Psecond.diskAddr.volid ) status1 = 0x100 ;
	else if ( Pfirst.diskAddr.volid > Psecond.diskAddr.volid ) status2 = 0x100 ;

	if ( Pfirst.diskAddr.page  < Psecond.diskAddr.page  ) 
		status1 = status1 + 0x010 ;
	else if ( Pfirst.diskAddr.page  > Psecond.diskAddr.page  ) 
		status2 = status2 + 0x010 ;


	if ( Pfirst.diskAddr.slot  < Psecond.diskAddr.slot  ) 
		status1 = status1 + 0x001 ;
	else if ( Pfirst.diskAddr.slot  > Psecond.diskAddr.slot  ) 
		status2 = status2 + 0x001 ;

	switch ( Pcondition ) 
	{
		case T_EQ : if ( ( status1 | status2 ) == 0  ) return(1);
			    else return(0) ;

		case T_LT : if ( status1 > status2 ) return(0) ;
			    else return(1) ;

		case T_GT : if ( status1 < status2 )   return(1) ; 
			   else  return(0) ;
	}  
	return 0;
}

void display_Oid(OID oid)
{
	printf(" %d %d %d %d\n", oid.diskAddr.page, oid.diskAddr.slot, oid.diskAddr.volid, oid.diskAddr.unique ); 
};

void read_Oid(OID *oid)
{/*
	int 	ynloop,trueloop;
	char 	choice;

	do {
		printf("page#        slot#        vol#         unique#\n");
		cin >> oid->diskAddr.page ;
		cin >> oid->diskAddr.slot ;
		cin >> oid->diskAddr.volid ;
		cin >> oid->diskAddr.unique ;
		cout << "given oid is :....\n" ;
		cout << oid->diskAddr.page ;
		cout << oid->diskAddr.slot ;
		cout << oid->diskAddr.volid ;
		cout << oid->diskAddr.unique ;

      		do {
           		cout << "is this true [y|n]:";
           				cin >> choice ;
           		ynloop=1;
           		switch(choice) {
                 		case 'y'  :
                 		case 'Y'  : trueloop=0; ynloop=0;  break;
                 		case 'n'  :
                 		case 'N'  : trueloop=1; ynloop=0;  break;
		};
          } while (ynloop);
    } while (trueloop); */
};

ERTYPE ErrorCheck(int e,char *routine) 
{
	if(e!=esmNOERROR) {   // If there is not error do nothing..
		printf( "Got a ESM error from %s\n", routine);
		printf( "error= %s\n",sm_Error(sm_errno));
	}
	return(0);
};

int ESM_Startup() 
{
	int  	err, fidsize = sizeof( FID );
	char 	*errormsg;

	sm_ErrorStream=fopen("/dev/null","a");
	ErrStrm=sm_ErrorStream;

	mscat_Initialize("Initialization"); 
	//printf("initialization is successed \n");

	VolumeId = atoi(VOL) ;
	TransactionId=NULL;

	//mscat_OpenBufferGroup("can not open buffer group for cat group");
	//cout << "buffer group is opened \n";

	mscat_BeginTransaction(" can not start transaction ");
	//printf( "transaction is started \n");

	// read FID of Database File
	err = sm_GetRootEntry( VolumeId, msDB_FILE, &DBFile, &fidsize );

	// if Database File does not exist then create it
	if( sm_errno == esmBADROOTNAME ){
		//printf( "creating database file\n");
		mscat_CreateFile( DBFile, "creation database file");
		err = sm_SetRootEntry( VolumeId, msDB_FILE, (char *) &DBFile, S_FID );
		if( err != esmNOERROR ) {
			catalogError.setError( EXODUS_ERROR, err, "SetRootEntry");
			return FALSE;
		}
		mscat_CommitTransaction("");
	}
	else if( err != esmNOERROR ) {
		catalogError.setError( EXODUS_ERROR, err, "Get Root Entry");
		mscat_CommitTransaction("");
		return FALSE;
	}
	mscat_CommitTransaction("");
	return TRUE;
}
        
int ESM_ShutDown() 
{
	int   	err;
	char 	*errormsg;

	mscat_ShutDown(" can not shut down ESM");
	//printf("connection shut down.....bye \n");
	return TRUE;
}

      
