#include "mood_catalog.h"
#include "linklist.h"
#include "classddl.h"


void addTypeDef( char *typeType, char *typeName )
{
	FILE	*msTypeDefs;
	char	fileName[120];

	sprintf( fileName, "%s/ms_typedefs.h", DatabaseHome );
	msTypeDefs = fopen( fileName, "a");
	fprintf( msTypeDefs, "#ifndef __%s_%s\n", typeType, typeName );
	fprintf( msTypeDefs, "#define __%s_%s\n", typeType, typeName );
	fprintf( msTypeDefs, "class  %s_%s\n", typeType, typeName );
	fprintf( msTypeDefs, "{\n" );
	fprintf( msTypeDefs, "	OID adresofObjest;\n" ); 
	fprintf( msTypeDefs, "};\n"); 
	//fprintf( msTypeDefs, "typedef OID %s_%s; // 1\n", typeType, typeName );
	fprintf( msTypeDefs, "#endif\n\n");
	fclose( msTypeDefs );
}

void CreateHeader::itoa( int i, char *val )
{
	int 	j  = 0;    
    
	do{
		val[ j ] = '0' + i % 10;
		i /= 10;
		j++;
	} while( i );

	val[ j ] = '\0';
}

char  *CreateHeader::generateName()
{
	static int i=0;
	char str[20];

	char *name=(char *)malloc(MAXSTRLEN);
	strcpy(name,"dummy");
	itoa(i++, str);
	strcat(name, str);
	return  name;
}

void CreateHeader::manipulateset(memberNode *p)
{

	if (!strcmp(p->memberName,"")) strcpy(p->memberName,generateName());

	fprintf(whichFile,"SET_%s %s;\n",  p->subAttributes->typeName, p->memberName );
	addTypeDef( "SET", p->subAttributes->typeName );

	if((p->subAttributes->type == ST ) || (p->subAttributes->type ==LST )
		|| (p->subAttributes->type == RF ))
		fprintf(whichFile,"/* not permitted yet */ \n");
}

void CreateHeader::manipulatelist(memberNode *p)
{

	if (!strcmp(p->memberName,"")) strcpy(p->memberName,generateName());
	fprintf(whichFile,"LIST_%s %s;\n",  p->subAttributes->typeName, p->memberName );
	addTypeDef( "LIST", p->subAttributes->typeName );
	if((p->subAttributes->type == ST ) || (p->subAttributes->type ==LST )
	|| (p->subAttributes->type == RF ))
	fprintf(whichFile,"/* not permitted yet */ \n");
}
void  CreateHeader::maketpldef(memberNode *p)
{
	while(p){
		switch(p->type){
			case INT  : 
				fprintf(whichFile,"%s%s%c\n", "int " , p->memberName ,';');
				break;
			case FLT  : 
				fprintf(whichFile,"%s%s%c\n","float ", p->memberName ,';');
				break;
			case BL   : 
				fprintf(whichFile,"%s%s%c\n","boolean ",p->memberName ,';');
				break;
			case CHR  : 
				fprintf(whichFile,"%s%s%c\n", "char " , p->memberName,';');
				break;
			case STR  : 
				fprintf(whichFile,"%s%s%c%d%c%c\n","char " ,p->memberName, '[' ,p->size , ']' ,';' );
				break;
			case TPL  : 
				traverse(p);
				break;
			case ST   : 
				traverse(p);
				break;
			case LST  : 
				traverse(p);
				break;
			case RF   : 
				fprintf(whichFile,"REF_%s %s;\n",  p->subAttributes->typeName, p->memberName );
				addTypeDef( "REF", p->subAttributes->typeName );
				break;
			default :
				fprintf(whichFile,"%s %s;\n",  p->typeName, p->memberName );
				break;
				
		}/*end switch*/
		p=p->attributeList;
	}/*end while */
}/*end maketpldef */

void CreateHeader::traverse(memberNode *p)
{
  //printf("p->type=%d\n", p->type );
  switch(p->type) {
     case INT  : fprintf(whichFile,"%s%s%c \n", "int " , p->memberName, ';');
	          break;
     case FLT  : fprintf(whichFile,"%s%s%c \n", "float " , p->memberName ,';');
		  break;
     case BL   : fprintf(whichFile,"%s%s%c \n" , "boolean " , p->memberName, ';');
	          break;
     case CHR  : fprintf(whichFile,"%s%s%c \n" , "char " , p->memberName ,';');
		  break;
     case STR  : fprintf(whichFile,"%s%s%c%d%c%c \n","char " ,p->memberName,
			    '[',p->size, ']',';');
		  break;
     case TPL  : printf(" inside tuple \n ") ;
                    fprintf(whichFile,"%s\n" ,"struct {");
		    maketpldef(p->subAttributes);
		    if(p->memberName)
			fprintf(whichFile,"%c%s%c\n",'}',p->memberName,';');
		    else fprintf(whichFile,"%c%c\n",'}' , ';');
		  break;
     case ST  : manipulateset(p);
		    if (p->subAttributes->type== TPL)
		       maketpldef(p->subAttributes);
		  break;
     case LST :  manipulatelist(p);
		    if (p->subAttributes->type== TPL )
		      maketpldef(p->subAttributes);
		    break;
     case RF  :  
		fprintf(whichFile,"REF_%s %s;\n",  p->subAttributes->typeName, p->memberName );
		
		addTypeDef( "REF", p->subAttributes->typeName );
		    break;
  }; /* end switch*/
} /* end traverse */

void CreateHeader::writeinheritList(LinkedList *inheritList)
{
  inherits *in=(inherits *)inheritList->getFirstEntry();
  fprintf( whichFile, " : " );

  if (in->protectionFlag == cpPUBLIC){
	if (in->virtualFlag)
	  fprintf(whichFile,"%s%s", "virtual public  " ,in->cname);
	else
	  fprintf(whichFile,"%s%s", "public  " ,in->cname);
  }else{
	if (in->virtualFlag)
	  fprintf(whichFile,"%s%s", "virtual private  " ,in->cname);
	else
	  fprintf(whichFile,"%s%s", "private  " ,in->cname);
  }

  in=(inherits *)inheritList->getNextEntry();
  while(in){
      if (in->protectionFlag == cpPUBLIC){
	if (in->virtualFlag)
	  fprintf(whichFile,"%c%s%s", ',' ,"virtual public  " ,in->cname);
	else
	  fprintf(whichFile,"%c%s%s", ',' ,"public  " ,in->cname);
      }else{
	if (in->virtualFlag)
	  fprintf(whichFile,"%c%s%s", ',' ,"virtual private  " ,in->cname);
	else
	  fprintf(whichFile,"%c%s%s", ',' ,"private  " ,in->cname);
      }
      in=(inherits *)inheritList->getNextEntry();
  } /*end while */
  fprintf(whichFile,"\n");
}




void CreateHeader::createheaderfile( char *cName, LinkedList *inherits, memberNode *mNode )
{
	FILE	*dbHeader, *clsHeader;
	char filename[MAXSTRLEN+2],name[MAXSTRLEN+4];
	char	command[180];
	//printf(" Inside createclassheader\n" );

	// add entry "class cName;" to classes.h
	sprintf( filename, "%s/classes.h", DatabaseHome );
	clsHeader = fopen( filename, "a" );
	fprintf( clsHeader, "class %s;\n", cName );
	fclose( clsHeader );

	// add entry "#include <cName.h>" to database.h
	sprintf( filename, "%s/database.h", DatabaseHome );
	dbHeader = fopen( filename, "a" );
	fprintf( dbHeader, "#include <%s.h>\n", cName );
	fclose( dbHeader ); 

	

	sprintf( filename, "%s/%s.h", DatabaseHome, cName );
	whichFile=fopen(filename,"w");

	fprintf( whichFile, "#ifndef __%s_h\n#define __%s_h\n\n", cName, cName );

	if( !inherits ) 
		fprintf(whichFile,"%s%s%c%s\n","class ",cName,':', "public MoodsRoot");
	else
		fprintf(whichFile,"%s%s\n","class ",cName );

	if( inherits ) writeinheritList(inherits);
	if( mNode ) {
		fprintf(whichFile,"{ \n");
		fprintf(whichFile,"public : \n");
		//printf("type id = %d \n", mNode->type );
		if(mNode->type == TPL ) maketpldef(mNode->subAttributes);
		//else printf("Only TUPLE is allowed as the outermost type \n"); 
		fprintf(whichFile,"};\n\n#endif //__%s_h\n", cName);
	} else {
		fprintf( whichFile, ";\n\n#endif //__%s_h\n", cName );
	}

	fclose(whichFile);
	
	/*sprintf( command, "mkdir %s/%s", DatabaseHome, cName );
	system( command );*/

}
