#ifndef __BJNDXDDL_H
#define __BJNDXDDL_H

#ifndef __STRING_H
#define __STRING_H
#include <string.h>
#endif

#ifndef __REQROOT_H
#include <reqroot.h>
#endif

#ifndef __KEYWORDS_H
#include <keywords.h>
#endif

#ifndef __LINKLIST_H
#include <linklist.h>
#endif

/****************************************************************************

	BJIndexCreate keeps all information about CREATE INDEX statement

****************************************************************************/
	


class BJIndexCreate : public RequestRoot
{
public :
	char 		indexName[MAXSTRLEN]; // name of the index
	char 		className[MAXSTRLEN]; // name of the class 
//	LinkedList	*attributeList;

			BJIndexCreate(UserRequest *);
	void 		setIndexName(char *);
	void 		setClassName(char *);
	void 		connectUserRequest();
			parse();
	
};


inline void BJIndexCreate::setIndexName(char *iName)
{
	strcpy(indexName, iName);
}

inline void BJIndexCreate::setClassName(char *cName)
{
	strcpy(className, cName);
}

inline void BJIndexCreate::connectUserRequest()
{
	ur->operation            = VOID this;
	ur->operationType        = CREATE_BJINDEX;
	ur->operationTypeOnError = CREATE_BJINDEX;
}


/***********************************************************************
	
	BJIndexDrop class handles DROP BINARY JOIN INDEX statement

***********************************************************************/

class BJIndexDrop : public RequestRoot
{
public :
	char 		indexName[MAXSTRLEN]; //name of the index to be dropped

	void		setIndexName(char *);
	void		connectUserRequest();
			parse();
			BJIndexDrop( UserRequest *userReq);
};

inline BJIndexDrop::BJIndexDrop( UserRequest *userReq)
{
	ur = userReq;
} 


inline void BJIndexDrop::setIndexName(char *iName)
{
        strcpy(indexName, iName);
}

inline void BJIndexDrop::connectUserRequest()
{
        ur->operation     = VOID this;
        ur->operationType = DROP_BJINDEX;
	ur->operationTypeOnError = DROP_BJINDEX;
}

#endif // __BJNDXDDL_H
