#ifndef __BPLUSDDL_H
#define __BPLUSDDL_H

#ifndef __STRING_H
#define __STRING_H
#include <string.h>
#endif

#ifndef __REQROOT_H
#include "reqroot.h"
#endif

#ifndef __KEYWORDS_H
#include "keywords.h"
#endif

#ifndef __LINKLIST_H
#include "linklist.h"
#endif

typedef char msBOOLEAN;



/***********************************************************************

	IndexedAttribute class keeps information about indexed
	attribute which is used in CREATE INDEX statement.

***********************************************************************/

class IndexedAttribute
{
public :
	char		attributeName[MAXSTRLEN];
	char		order;

	IndexedAttribute(){ order = ASCENDING; }
	void setAttributeName(char *);
	void setOrder();
};


void inline IndexedAttribute::setAttributeName( char * aName)
{
	strcpy(attributeName, aName);
}


void inline IndexedAttribute::setOrder()
{
	order = DESCENDING;
}





/****************************************************************************

	IndexCreate keeps all information about CREATE INDEX statement

****************************************************************************/
	


class IndexCreate : public RequestRoot
{
public :
	char 		indexName[MAXSTRLEN]; // name of the index
	char 		className[MAXSTRLEN]; // name of the class 
	char		uniqueFlag; // index is unique or not
	LinkedList	*attributeList;

			IndexCreate(UserRequest *);
	void 		setIndexName(char *);
	void 		setClassName(char *);
	void 		setUniqueFlag();
	void 		connectUserRequest();
			execute();
			parse();
	
};

inline void IndexCreate::setIndexName(char *iName)
{
	strcpy(indexName, iName);
}

inline void IndexCreate::setClassName(char *cName)
{
	strcpy(className, cName);
}

inline void IndexCreate::setUniqueFlag()
{
	uniqueFlag = TRUE;
}

inline void IndexCreate::connectUserRequest()
{
	ur->operation     = VOID this;
	ur->operationType = CREATE_INDEX;
	ur->operationTypeOnError = CREATE_INDEX;
}




/***********************************************************************
	
	IndexDrop class handles DROP INDEX statement


***********************************************************************/

class IndexDrop : public RequestRoot
{
public :
	char 		indexName[MAXSTRLEN]; //name of the index to be dropped

	void		setIndexName(char *);
	void		connectUserRequest();
			execute();
			parse();
			IndexDrop( UserRequest *userReq) 
			{
				ur = userReq;
			} 
};


inline void IndexDrop::setIndexName(char *iName)
{
        strcpy(indexName, iName);
}

inline void IndexDrop::connectUserRequest()
{
        ur->operation     = VOID this;
        ur->operationType = DROP_INDEX;
	ur->operationTypeOnError = DROP_INDEX;
}

#endif // __BPLUSDDL_H
