#ifndef __INDEX_H
#define __INDEX_H

#include <mood_catalog.h>

#ifndef  MAXSTRLEN
#define  MAXSTRLEN 100
#endif


#ifndef __STRING_H
#define __STRING_H
#include <string.h>
#endif

#ifndef __USERREQ_H
#include "userreq.h"
#endif

#ifndef __REQROOT
#include "reqroot.h"
#endif



#define BTREE  0
#define MS_HASH   1


struct IndexEntry:public CatRoot{
     char indexName[MAXSTRLEN];
     char className[MAXSTRLEN];
     char attrName[ MAXSTRLEN];
     int attrType;
     char uniqueFlag;
     char indexType;
//     int attrLength;
     IID indexID;
};

class IndexClass: public RequestRoot{
     struct IndexEntry indexEntry;
public:
     IndexClass( UserRequest * );
     void connectUserRequestCreate();
     void connectUserRequestDrop();
     void freeAttributes( AttrList * );
     int  createIndexParser();
     int  dropIndexParser();
     int getTypeLengthOffset( AttrList *, char *, int *, int *, int * );
     void setAttrType( char *, int * );
     void dropIndex( char *, BOOL * );
     void createIndex( char *, char *, char *, BOOL, char, BOOL *);
     OID insertIndexEntry( FID, char *, char *, char *, int, int, IID );
     void checkIndexName( FID, char *, BOOL *);
     IID getIID( char *, char *, CatBOOLEAN * );
};


inline IndexClass::IndexClass( UserRequest *userReq )
{
    ur = userReq;
    indexEntry.uniqueFlag=0;// 1 if the index is unique and 1 otherwise
    indexEntry.indexType=BTREE; // 0 for B+tree and 1 for HASH index
}

inline void IndexClass::connectUserRequestCreate()
{
   ur->operation            = (void *)this;
   ur->operationType        = CREATE_INDEX;
   ur->operationTypeOnError = CREATE_INDEX;
}
inline void IndexClass::connectUserRequestDrop()
{
   ur->operation            = (void *)this;
   ur->operationType        = DROP_INDEX;
   ur->operationTypeOnError = DROP_INDEX;
}
#endif
