#ifndef __MOODS_DEFS
#define __MOODS_DEFS

#define BUFGRP      		int  
#define NTYPE       		int  
#define ERTYPE      		int 
#define TYPEID      		int 
#define SIZTYP     		int  
#define CatBOOLEAN    		char
#define GRPSIZE     		50	
#define VOL         		getenv("EVOLID")
#define INT32       		int
#define T_EQ                    0x00
#define T_LT                    0x10
#define T_GT                    0x01
#define CatBOOLEAN              char
#define MAXDBNAME               100
#define SEQ_MAXNAME             20
#define SEQFILE                 "$SEQFILE"
#define INCR_MULTIPLIER         5
#define SEQNAME                 "$MoodsType"
#define SYS                     0
#define USER                    1
#define MAXATTR                 100
#ifndef MAXSTRLEN
#define MAXSTRLEN               100
#endif
#define MAXINHERITS             40
#define MAXCLASS                100
#define MAXFUNC                 20
#define MAX_FUN_NAME            50
#define MAX_FUN_SIGN            100
#define S_OID                   sizeof(OID)
#define S_FID                   sizeof(FID)
#define S_CATALOG               sizeof(Catalog)
#define S_TypeId    		sizeof(TypeId)
#define S_INT32     		sizeof(int)

// define built-in types ******
#define TYPE_TUPLE              9
#define TYPE_SET               10
#define TYPE_LIST              11 
#define TYPE_REF               12 
#define TYPE_ATTRIBUTE         15 
#define TYPE_CATALOG	       16
#define TYPE_FUNCTION          18

// define interface modes
#define TEXTUAL_MODE	1
#define GUI_MODE	2

#define msDB_FILE		"$$DATABASE_FILES$$"
// *********** end .....

// error handling macro for catalog
#define CAT_CHECK( _errorStatus, _errorNo, _errorMessage )\
	if( *_errorStatus) {\
		catalogError.setError( RUNTIME_ERROR, _errorNo, _errorMessage);\
		return FALSE;\
	}\

#define INTERNAL_CHECK( _errorStatus, _errorMessage )\
	if( *_errorStatus) {\
		catalogError.setError( INTERNAL_ERROR, 0, _errorMessage);\
		return FALSE;\
	}\

#define ERROR_HANDLER( _message )\
	if( err != esmNOERROR ) {\
		catalogError.setError( EXODUS_ERROR, err, _message);\
		return FALSE;\
	}\


#define mscat_ReadObject(_whichObject, _message )\
        err = sm_ReadObject( BufferGroup, &_whichObject, 0, READ_ALL, &UserDesc);\
	ERROR_HANDLER( _message ) \

#define mscat_DestroyObject(_whichObject, _message )\
        err = sm_DestroyObject( BufferGroup, &_whichObject);\
	ERROR_HANDLER( _message ) \

#define mscat_ReleaseObject( _message )\
	if( UserDesc != NULL )\
	err = sm_ReleaseObject( UserDesc );\
	ERROR_HANDLER( _message ) \

#define mscat_CreateObject(_whichFile,_objSize,_objPtr,_retObj,_message)\
	err=sm_CreateObject(BufferGroup,&_whichFile,NEAR_FIRST_PHYSICAL,\
			NULL, NULL, _objSize, _objPtr, _retObj );\
	ERROR_HANDLER( _message ) \

#define mscat_WriteObject( _objSize, _objPtr, _message )\
	err = sm_WriteObject( BufferGroup, 0, _objSize, _objPtr, UserDesc, TRUE );\
	ERROR_HANDLER( _message ) \

#define mscat_CreateFile(_whichFile, _message )\
        err = sm_CreateFile( BufferGroup, VolumeId, &_whichFile );\
	ERROR_HANDLER( _message ) \

#define mscat_DestroyFile(_whichFile, _message )\
        err = sm_DestroyFile( BufferGroup, &_whichFile );\
	ERROR_HANDLER( _message ) \

#define mscat_DestroyIndex( _whichIndex, _message )\
	err = sm_DestroyIndex( &_whichIndex, BufferGroup );\
	ERROR_HANDLER( _message )\

#define mscat_CreateIndex( _indexType, _whichIndex, _keyType, _keyLength, _unique, _message )\
	err=sm_CreateIndex(VolumeId,BufferGroup,_indexType,_keyType,_keyLength, sizeof(OID),_unique,&_whichIndex);\
	ERROR_HANDLER( _message )\

#define mscat_InsertEntry( _indexID, _key, _element, _message )\
	err=sm_InsertEntry( &_indexID, BufferGroup, &_key, &_element );\
	ERROR_HANDLER( _message )\

#define mscat_BeginTransaction( _message )\
        err = sm_BeginTransaction(&TransactionId);\
	ERROR_HANDLER( _message ) \

#define mscat_CommitTransaction( _message )\
        err=sm_CommitTransaction(TransactionId);\
	ERROR_HANDLER( _message ) \

#define mscat_OpenBufferGroup( _message )\
        err=sm_OpenBufferGroup(20,BF_MRU,&BufferGroup,NOFLAGS);\
	ERROR_HANDLER( _message ) \

#define mscat_CloseBufferGroup( _message )\
        err=sm_CloseBufferGroup(BufferGroup);\
	ERROR_HANDLER( _message ) \

#define mscat_Initialize( _message )\
	err=sm_Initialize();\
	ERROR_HANDLER( _message );\

#define mscat_ShutDown( _message )\
        err=sm_ShutDown();\
	ERROR_HANDLER( _message ) \

#define mscat_GetFirstOid( _whichFile, _whichOid, _message )\
	err = sm_GetFirstOid( BufferGroup, &_whichFile, &_whichOid, &ObjectHeader, &eof );\
	ERROR_HANDLER( _message ) \

#define mscat_GetNextOid( _currOid, _nextOid, _message )\
	err = sm_GetNextOid( BufferGroup, &_currOid, &_nextOid, &ObjectHeader, &eof );\
	ERROR_HANDLER( _message ) \

#endif __MOODS_DEFS
