/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/expr_str.h,v 1.16 92/11/18 01:32:48 bill Exp Locker: bill $ 
*
*/ 

#if defined(GET_STATS)
#define deallocate(ptr) {++num_frees; free ((char *) (ptr)) ;}
#else
#define deallocate(ptr) {free ((char *) (ptr));}
#endif
 
typedef struct HASH_INDEX_ENTRY
    {
	LOG_EXPR_LIST_ELEM	*first, *last ;
#ifdef GET_STATS
	long			entries ;
#endif
    } HASH_INDEX_ENTRY ;

#define HASH_TABLE_SIZE		5003	
#define EQ_CLASS_TABLE_SIZE	200	

typedef struct STORAGE_SEG_ANCHOR
    {
	HASH_INDEX_ENTRY	*base_hash_table ;
	int			hash_table_size ;
	struct EQ_CLASS_NODE	*base_eq_class_table ;
	int			eq_class_table_size ;
	int			eq_class_count ; 
	LOG_EXPR_LIST_ELEM	*original_lele ;
	int			calls_to_fbp ;
	int			rule_group ;
	int			calls_to_optimize ;
    } STORAGE_SEG_ANCHOR ;

#if SAFETY>=1
#define get_eq_class_addr(ssa,eq_class_index,eqp) {\
	if ((eq_class_index) <0 || (eq_class_index) > (ssa) -> eq_class_count) \
	    FAIL (ERR_INDEX_OUT_OF_RANGE) ;\
	if ((ssa)->base_eq_class_table [(eq_class_index)].flag != OCCUPIED)\
	   FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;\
	if ((ssa)->base_eq_class_table [(eq_class_index)].eq_ptr == NULL)\
	   FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;\
	*(eqp) = (ssa) -> base_eq_class_table [(eq_class_index)].eq_ptr ;\
        }
#else
#define get_eq_class_addr(ssa,eq_class_index,eqp) \
	*(eqp) = (ssa) -> base_eq_class_table [(eq_class_index)].eq_ptr ;
#endif

typedef struct EQ_CLASS_NODE 
    {
	EQ_CLASS *		eq_ptr ;
	int 			flag ;
    } EQ_CLASS_NODE ;

#define hash_fct(log_expr, bucket) {\
	REG int i_zix ;\
	bucket = ((unsigned long) \
		(((int) (log_expr)->my_operator)*HASH_TABLE_SIZE)) >> 1 ;\
	for (i_zix = opt_arity[(int) (log_expr->my_operator)]; --i_zix >= 0;) \
        {\
	    bucket += (((unsigned long) (log_expr -> input[i_zix])) >> (i_zix*2 + 1));\
        }\
        bucket = bucket % HASH_TABLE_SIZE ;}

#ifdef GET_STATS
#define init_log_expr_list(p)	(p) -> first = NULL ;\
				(p) -> count = 0 ; \
				(p) -> last = NULL ;
#else
#define init_log_expr_list(p)	(p) -> first = NULL ;\
				(p) -> last = NULL ;
#endif

#ifdef GET_STATS
#define init_phy_expr_list(p)	(p) -> first = NULL ;\
				(p) -> count = 0 ; \
				(p) -> last = NULL ;
#else
#define init_phy_expr_list(p)	(p) -> first = NULL ;\
				(p) -> last = NULL ;
#endif

#ifdef GET_STATS
#define allocate_eq_class(ssa, eq_ptr) \
	*(eq_ptr) = (EQ_CLASS *) malloc ((unsigned) sizeof (EQ_CLASS));\
	if (*(eq_ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
	++num_mallocs ;\
        CHECK (init_eq_class(ssa, eq_ptr)) ;
#else
#define allocate_eq_class(ssa, eq_ptr) \
	*(eq_ptr) = (EQ_CLASS *) malloc ((unsigned) sizeof (EQ_CLASS));\
	if (*(eq_ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
        CHECK (init_eq_class(ssa, eq_ptr)) ;
#endif

#ifdef GET_STATS
#define allocate_eq_class_table(eqt) \
	(eqt) = (EQ_CLASS_NODE *) malloc ((unsigned) (EQ_CLASS_TABLE_SIZE\
		* sizeof (EQ_CLASS_NODE))) ;\
	++num_mallocs ;\
	if ((eqt) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}
#else
#define allocate_eq_class_table(eqt) \
	(eqt) = (EQ_CLASS_NODE *) malloc ((unsigned) (EQ_CLASS_TABLE_SIZE\
		* sizeof (EQ_CLASS_NODE))) ;\
	if ((eqt) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}
#endif

#define init_log_expr(p)		 init_operator_arg\
				            (&((p) -> argument)) ;\
					 {int i_ziz ;\
					 for (i_ziz = MAX_OPERATOR_ARITY;\
					      --i_ziz >= 0;)\
					      (p) -> input[i_ziz] = NULL;}

#ifdef KEEP_TRANS_INFO
#define init_trans_info(tp) { \
    (tp) -> list_size = INITIAL_TRANS_LIST_SIZE ; \
    (tp) -> trans_list_ptr = NULL ; \
    (tp) -> count = 0 ;}
#endif

#ifdef GET_STATS
#define init_log_expr_list_elem(ptr) 	 (ptr) -> next = NULL ;\
		 (ptr) -> hash_next= NULL ;\
		 (ptr) -> hash_prev= NULL ;\
		 (ptr) -> prev = NULL ;\
		 (ptr) -> eq_class_index = -1 ;\
		 (ptr) -> ref_count = 0 ;\
		 (ptr) -> depth = -1 ;\
		 (ptr) -> last_rule = -1 ; \
		 (ptr) -> rule_generated_from = -1 ; \
		 init_log_expr(&((ptr) -> expr)) ;
#else
#define init_log_expr_list_elem(ptr) 	 (ptr) -> next = NULL ;\
		 (ptr) -> hash_next= NULL ;\
		 (ptr) -> hash_prev= NULL ;\
		 (ptr) -> prev = NULL ;\
		 (ptr) -> eq_class_index = -1 ;\
		 (ptr) -> depth = -1 ;\
		 (ptr) -> last_rule = -1 ; \
		 (ptr) -> rule_generated_from = -1 ; \
		 init_log_expr(&((ptr) -> expr)) ;
#endif


#if defined(KEEP_TRANS_INFO) && !defined(GET_STATS)
#define allocate_log_expr_list_elem(ptr) \
	(ptr) = (LOG_EXPR_LIST_ELEM *) \
		malloc ((unsigned) sizeof (LOG_EXPR_LIST_ELEM)) ;\
	if ((ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
        init_log_expr_list_elem(ptr) ; \
	init_trans_info (&((ptr) -> trans_info)) ; 
#endif

#if defined(KEEP_TRANS_INFO) && defined(GET_STATS)
#define allocate_log_expr_list_elem(ptr) \
	(ptr) = (LOG_EXPR_LIST_ELEM *) \
		malloc ((unsigned) sizeof (LOG_EXPR_LIST_ELEM)) ;\
	if ((ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
	++num_mallocs ;\
        init_log_expr_list_elem(ptr) ; \
	init_trans_info (&((ptr) -> trans_info)) ; 
#endif

#if !defined(KEEP_TRANS_INFO) && !defined(GET_STATS)
#define allocate_log_expr_list_elem(ptr) \
	(ptr) = (LOG_EXPR_LIST_ELEM *) \
		malloc ((unsigned) sizeof (LOG_EXPR_LIST_ELEM)) ;\
	if ((ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
        init_log_expr_list_elem(ptr) ;
#endif

#if !defined(KEEP_TRANS_INFO) && defined(GET_STATS)
#define allocate_log_expr_list_elem(ptr) \
	(ptr) = (LOG_EXPR_LIST_ELEM *) \
		malloc ((unsigned) sizeof (LOG_EXPR_LIST_ELEM)) ;\
	if ((ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
	++num_mallocs ;\
        init_log_expr_list_elem(ptr) ;
#endif


#ifdef USE_PE_HASH
#define init_phy_expr_list_elem(ptr) (ptr) -> next = NULL ; \
		     (ptr) -> expr = NULL ; \
		     (ptr) -> prev = NULL ; \
		     (ptr) -> hash_next = NULL ; \
		     (ptr) -> lele = NULL ; \
		     init_cost(&((ptr) -> fail_cost)) ;\
		     (ptr) -> fail_reason = REASON_NOT_SET; \
		     (ptr) -> failure_exists = FALSE; \
		     init_property_vec \
			(&((ptr) -> property_vector)) ; \
		     init_property_vec \
			(&((ptr) -> excl_property_vector)); \
		     (ptr) -> eq_class_index = -1 ;
#else
#define init_phy_expr_list_elem(ptr) (ptr) -> next = NULL ; \
		     (ptr) -> expr = NULL ; \
		     (ptr) -> prev = NULL ; \
		     (ptr) -> lele = NULL ; \
		     init_cost(&((ptr) -> fail_cost)) ;\
		     (ptr) -> fail_reason = REASON_NOT_SET; \
		     (ptr) -> progress_flag = INITIALIZED_ONLY; \
		     (ptr) -> failure_exists = FALSE; \
		     init_property_vec \
			(&((ptr) -> property_vector)) ; \
		     init_property_vec \
			(&((ptr) -> excl_property_vector)); \
		     (ptr) -> eq_class_index = -1 ;
#endif

#if defined (GET_STATS)
#define allocate_phy_expr_list_elem(ptr) \
	(ptr) = (PHY_EXPR_LIST_ELEM *) \
		malloc ((unsigned) sizeof (PHY_EXPR_LIST_ELEM)) ;\
	if ((ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
	++num_mallocs ;\
        init_phy_expr_list_elem(ptr) ;
#else
#define allocate_phy_expr_list_elem(ptr) \
	(ptr) = (PHY_EXPR_LIST_ELEM *) \
		malloc ((unsigned) sizeof (PHY_EXPR_LIST_ELEM)) ;\
	if ((ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
        init_phy_expr_list_elem(ptr) ;
#endif

#define init_phy_expr(p)		init_algorithm_arg\
					  (&((p) ->algorithm_argument)) ;\
					init_cost(&((p) -> cost)) ;\
					(p) -> ref_count = 0 ;\
					(p) -> plan = NULL ;\
					(p) -> num_inputs = 0 ;\
					(p) -> derived_pele = NULL ;\
					 {int i_ziz ;\
					 for (i_ziz = MAX_ALGORITHM_ARITY;\
					      --i_ziz >= 0;)\
					      (p) -> input[i_ziz] = NULL;}

#if defined (GET_STATS)
#define allocate_phy_expr(ptr) \
	(ptr) = (PHY_EXPR *) malloc ((unsigned) sizeof (PHY_EXPR)) ;\
	if ((ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
	++num_mallocs ;\
	init_phy_expr(ptr) ;
#else
#define allocate_phy_expr(ptr) \
	(ptr) = (PHY_EXPR *) malloc ((unsigned) sizeof (PHY_EXPR)) ;\
	if ((ptr) == NULL) {FAIL (ERR_MEM_ALLOC_FAILED) ;}\
	init_phy_expr(ptr) ;
#endif

#ifdef USE_MACROS
#ifdef USE_PE_HASH
#define mfind_phy_expr_list_elem(eq_class,start,pv,excl_pv,ret_ptr) { \
    PHY_EXPR_LIST_ELEM *temp;int bucket; *(ret_ptr)=NULL;\
    if ((start) == NULL) {pe_hash_fct((pv),(excl_pv),&(eq_class->logical_property),&(eq_class->system_property),&bucket);\
        temp=(eq_class)->phy_expr_list.hash_table[bucket].first ;} else temp = (start)->hash_next ;\
    for (;temp!=NULL;temp=temp->hash_next) {\
	PV_COMPARE pv_comp;\
	compare_property_vec(&(temp -> property_vector),(pv),&((eq_class)->system_property),&((eq_class)->logical_property),&pv_comp);\
	if (pv_comp==PV_EQUAL) {\
	    compare_property_vec (&(temp->excl_property_vector),(excl_pv),&((eq_class)->system_property),&((eq_class)->logical_property),&pv_comp);\
	if (pv_comp==PV_EQUAL) {*(ret_ptr)=temp;break;}}}}
#else
#define mfind_phy_expr_list_elem(eq_class,start,pv,excl_pv,ret_ptr) { \
PHY_EXPR_LIST_ELEM *temp ; *(ret_ptr)=NULL; \
    if ((start) == NULL) temp = (eq_class) -> phy_expr_list.last;\
    else temp = (start) -> prev ;\
    for (; temp != NULL; temp = temp -> prev) {\
        PV_COMPARE pv_comp; \
        compare_property_vec (&(temp -> property_vector), (pv), &((eq_class)->system_property), &((eq_class)->logical_property),&pv_comp);\
        if (pv_comp == PV_EQUAL) {\
            compare_property_vec (&(temp -> excl_property_vector), (excl_pv), &((eq_class)->system_property), &((eq_class)->logical_property),&pv_comp);\
        if (pv_comp == PV_EQUAL) {*(ret_ptr) = temp; break;}}}}
#endif
#endif

#ifdef USE_MACROS
#define mmodify_dominated_pele(m_pele,m_phy_expr,m_lele) { \
	if ((m_pele)==NULL || (m_phy_expr)==NULL || (m_lele) == NULL) \
	    {FAIL(ERR_NULL_POINTER);}\
	if ((m_pele)->expr != (m_phy_expr)) \
	{ \
	    if ((m_pele) -> expr && \
		(--((m_pele) -> expr -> ref_count) == 0)) \
	    { \
		deallocate ((m_pele) -> expr) ; \
	    } \
	    (m_pele) -> expr = m_phy_expr ; \
	    (m_pele) -> lele = (m_lele) ; \
	    ++((m_phy_expr) -> ref_count) ; \
	}}	
#endif
