
#define delete_log_expr_list_elem(ptr) { \
    if ((ptr) == NULL) {FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;} \
    remove_lele_from_hash_index ((ptr)) ; \
    remove_lele_from_log_expr_list((ptr)) ; \
    bzero ((char *) ptr, sizeof (LOG_EXPR_LIST_ELEM)) ; \
    deallocate ((ptr)) ; }

#ifdef GET_STATS 
#define remove_lele_from_log_expr_list(ptr) { \
    EQ_CLASS	*temp_eq_class ; \
    if ((ptr) == NULL) {FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;} \
    get_eq_class_addr ((ptr) -> eq_class_index, &temp_eq_class) ;
    if (temp_eq_class -> log_expr_list.first == (ptr)) \
        temp_eq_class -> log_expr_list.first = (ptr) -> next ; \
    if (temp_eq_class -> log_expr_list.last == (ptr)) \
        temp_eq_class -> log_expr_list.last = (ptr) -> prev ; \
    if ((ptr) -> prev) (ptr) -> prev -> next = (ptr) -> next ; \
    if ((ptr) -> next) (ptr) -> next -> prev = (ptr) -> prev ; \
    -- (temp_eq_class -> log_expr_list.count) ; }
#else
#define remove_lele_from_log_expr_list(ptr) { \
    EQ_CLASS	*temp_eq_class ; \
    if ((ptr) == NULL) {FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;} \
    get_eq_class_addr ((ptr) -> eq_class_index, &temp_eq_class) ;
    if (temp_eq_class -> log_expr_list.first == (ptr)) \
        temp_eq_class -> log_expr_list.first = (ptr) -> next ; \
    if (temp_eq_class -> log_expr_list.last == (ptr)) \
        temp_eq_class -> log_expr_list.last = (ptr) -> prev ; \
    if ((ptr) -> prev) (ptr) -> prev -> next = (ptr) -> next ; \
    if ((ptr) -> next) (ptr) -> next -> prev = (ptr) -> prev ; }
#endif

#ifdef GET_STATS
#define insert_lele_in_hash_index(ptr) { \
    long bucket ; \
    hash_fct ((ptr) -> log_expr, bucket) ; \
    if (hash_index[bucket].first == NULL) \
	hash_index[bucket].first = (ptr) ; \
    else \
    { \
	(ptr) -> hash_prev = hash_index[bucket].last ; \
	(hash_index[bucket].last) -> hash_next = (ptr) ; \
    } \
    hash_index[bucket].last = (ptr) ; \
    ++ (hash_index[bucket].entries) ; }
#else
#define insert_lele_in_hash_index(ptr) { \
    long bucket ; \
    hash_fct ((ptr) -> log_expr, bucket) ; \
    if (hash_index[bucket].first == NULL) \
	hash_index[bucket].first = (ptr) ; \
    else \
    { \
	(ptr) -> hash_prev = hash_index[bucket].last ; \
	(hash_index[bucket].last) -> hash_next = (ptr) ; \
    } \
    hash_index[bucket].last = (ptr) ;
#endif


#ifdef GET_STATS
#define remove_lele_from_hash_index(ptr) { \
    int old_bucket ; \
    hash_fct ((ptr) -> expr, old_bucket) ; \
    if (hash_index[old_bucket].first == (ptr)) \
	hash_index[old_bucket].first = (ptr) -> hash_next ; \
    if (hash_index[old_bucket].last == (ptr)) \
	hash_index[old_bucket].last = (ptr) -> hash_prev ; \
    if ((ptr) -> hash_prev) (ptr) -> hash_prev -> hash_next = \
                            (ptr) -> hash_next ; \
    if ((ptr) -> hash_next) (ptr) -> hash_next -> hash_prev = \
                            (ptr) -> hash_prev ; \
    -- (hash_index[old_bucket].entries) ; }
#else
#define remove_lele_from_hash_index(ptr) {\
    int old_bucket ; \
    hash_fct ((ptr) -> expr, old_bucket) ; \
    if (hash_index[old_bucket].first == (ptr)) \
	hash_index[old_bucket].first = (ptr) -> hash_next ; \
    if (hash_index[old_bucket].last == (ptr)) \
	hash_index[old_bucket].last = (ptr) -> hash_prev ; \
    if (ptr -> hash_prev) ptr -> hash_prev -> hash_next = ptr -> hash_next ; \
    if (ptr -> hash_next) ptr -> hash_next -> hash_prev = ptr -> hash_prev ; }
#endif

