/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/parse.h,v 1.16 92/11/18 01:32:48 bill Exp Locker: bill $ 
*
*/ 
 
#define MAX_NAME		30
#define MAX_SYMBOLS		100
#define MAX_INPUTS		10
#define MAX_EXPR_PER_RULE	20
#define MAX_RULES		1000
#define MAX_GROUPS		10

typedef int STATUS ;

typedef enum {IS_ENFORCER, IS_ALGORITHM, IS_OPERATOR,
		IS_OPER_VARIABLE, IS_OP_ARG_VARIABLE, 
		IS_AL_ARG_VARIABLE, 
		IS_INPUT_VARIABLE, IS_NULL, FUNC_NOT_SET} FUNC ;
typedef enum {IMPL_RULE, TRANS_RULE} CURRENT_RULE_TYPE ;
typedef enum {LHS_CURRENT, RHS_CURRENT} CURRENT_RULE_SIDE ;
typedef enum {L_TO_R, L_TO_R1, TWO_WAY} RULE_DIRECTION ;
typedef enum {DECL_FUNC, PROCESS_RULE} CURRENT_PROCESS ;
typedef enum {DEFINED_IN_RHS, DEFINED_IN_LHS, DEFINED_NOT_SET} 
		DEFINED_IN ;
typedef enum {VAR_SET_IN_USER_CODE, VAR_NOT_SET} VAR_SET ;
typedef enum {USER_COND_CODE, USER_APPL_CODE, CODE_TYPE_NOT_SET}
	USER_CODE ;

typedef struct SYM_TAB
    {
	char		name [MAX_NAME] ;
	int		arity ;
	FUNC		func ;
	int 		id, bind_id ;
        int		rhs_count ;
	DEFINED_IN	defined_in ;
	VAR_SET		var_set ;
    } SYM_TAB ; 

typedef struct RULE_GROUP_TAB
    {
	int		group_id ;
	char		group_name[MAX_NAME] ;
    } RULE_GROUP_TAB ;

typedef struct RULE_PRIORITY_INFO
    {
	int		priority ;
    } RULE_PRIORITY_INFO ;

typedef struct RULE_EXPR
    {
	FUNC			func ;
	int			id ;
	int			arg_id ;
	int			arity ;
	int			node_id ;
	int			level ;
	int			group_id ;
	BOOLEAN			expr ;
	BOOLEAN			loop_over ;
	char			name [MAX_NAME] ;
	char			arg_name [MAX_NAME] ;
	struct RULE_EXPR	*input[MAX_INPUTS] ;
	struct RULE_EXPR	*parent ;
    } RULE_EXPR ;

