#ifndef __SET_H
#define __SET_H

#include <stdio.h>
//#include <strings.h>
#include <string.h>
#include <stdlib.h>
#include <setjmp.h>
#include "sm_client.h"
#include "mood_catdef.h"
#include "mood_catalog.h"

#define  MOODSSET  106 // Moods Set Type Classifier ....

// These definitions will be changed .....

#define  EXISTS  12345  /* OID value user wants to insert , already  there */
#define  NOTEXISTS 12346 /* OID value user wants to delete , not in the set */

/*     These definitions will be removed during entegration */

#define  F_NAME  "trial"

/*     Until This point .... */



//  ERTYPE return type means the error value of function ....
//  If an error (ESM or Logical) occurs return value is Error value
//  Othewise Set to 0........


class Set : public MoodsRoot {
      private:
        OID        SetOid;    // Oid of set object .......................
        OID       *ListHead;  // OID members start offset is pointed......
        void      *Buffer;    // Memory buffer to handle operations.......
        int        BufGrp;    // Buffer Group Universal variable is kept..
        TID        Tid;       // Transaction Id Universal variable is kept
        USERDESC  *UserDesc;  // User Descriptor for ESM .................
        FID        FileId;    // File ID (Given For Creation).............
        
        
      public:
        int  Size ;           // Size of current set......................
        int        ListPos;   // Current Position in set..................

        Set(OID *PSetOid,TYPEID *PTypeId,SIZTYP *PSize,CatBOOLEAN *PStatus);
        Set(FID *PFid,NTYPE PPos,OID *PNearOid, CatBOOLEAN *PStatus); 
        void   unpin() {sm_ReleaseObject(UserDesc);} ;
        void   getNext(OID *PEOid,CatBOOLEAN *PStatus);
        void   getPrev(OID *PEOid,CatBOOLEAN *PStatus);
        ERTYPE insertToSet(OID *POid,CatBOOLEAN *PStatus);
        ERTYPE deleteFromSet(OID POid,CatBOOLEAN *PStatus);
        ERTYPE isIn(OID POid,CatBOOLEAN  *PStatus);
        ERTYPE setUnion(Set PSet ,Set USet,CatBOOLEAN *PStatus);
        void   intersect(Set PSet , Set ISet , CatBOOLEAN *PStatus );
        ERTYPE isSubset(Set PSet,CatBOOLEAN *PStatus);
        ERTYPE isContain(Set PSet,CatBOOLEAN *PStatus);
        OID    getSetOid(CatBOOLEAN *PStatus) ;
        ERTYPE getElement(OID *POid ,int SetIndex,CatBOOLEAN *PStatus)  ;
        ERTYPE getFirst(OID *POid,CatBOOLEAN *PStatus) ;
        ERTYPE getLast(OID *POid,CatBOOLEAN *PStatus)  ;

};
#endif __SET_H
