#ifndef __INDEX_H
#define __INDEX_H
#endif

#ifndef __ATTRIBUTE_H_
#include <attribute.h>
#endif

#ifndef  MAXSTRLEN
#define  MAXSTRLEN 100
#endif


#ifndef __STRING_H
#define __STRING_H
#include <string.h>
#endif


#define BTREE  0
#define HASH   1
//#define UNIQUE 1


struct IndexEntry{
     char indexName[MAXSTRLEN];
     char className[MAXSTRLEN];
     char attrName[ MAXSTRLEN];
     int attrType;
     int attrLength;
     IID indexID;
};

struct IndInfo {
    char uniqueFlag;// 1 if the index is unique and 1 otherwise
    char indexType; // 0 for B+tree and 1 for HASH index
    char indexName[ MAXSTRLEN ];
    char className[ MAXSTRLEN ];
    char attrName[ MAXSTRLEN ];
};

class IndexClass{
     struct IndInfo indexInfo;
public:
     IndexClass( UserRequest * );
     void connectUserRequest();
     void freeAttributes( AttrList * );
     int  createIndexParser();
     int  dropIndexParser();
     int getTypeLengthOffset( AttrList *, char *, int *, int *, int * );
     void setAttrType( char *, int * );
     void dropIndex( char *, BOOL * );
     void createIndex( char *, char *, char *, BOOL, BOOL *);
     OID insertIndexEntry( FID, char *, char *, char *, int, int, IID );
     void checkIndexName( FID, char *, BOOL *);
     IID getIID( char *, char *, CatBOOLEAN * );
};


inline IndexClass::IndexClass( UserRequet *userReq )
{
    ur = userReq;
    indexInfo.uniqueFlag=0;// 1 if the index is unique and 1 otherwise
    indexInfo.indexType=BTREE; // 0 for B+tree and 1 for HASH index
}

inline void IndexClass::()
{
   ur->operation            = VOID this;
   ur->operationType        = CREATE_INDEX;
   ur->operationTypeOnError = CREATE_INDEX;
}
