
/*
 * timer.h
 *
 * Class definition for the times class.
 * Member functions are defined in times.c
 */
#ifndef  _timer
#define  _timer

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>

class Timer {

protected:
    struct timeval  time1;	/* gettimeofday() buffer */
    struct timeval  time2;	/* gettimeofday() buffer */
    struct rusage   rusage1;	/* getrusage() buffer */
    struct rusage   rusage2;	/* getrusage() buffer */

public:
    Timer()	{ }
    void   Start();		/* start gathering times  */
    void   Stop();		/* stop gathering times  */
    float  RealTime();		/* elapsed real time in micro-seconds */
    float  UserTime();		/* elapsed user time in micro-seconds */
    float  SystemTime();	/* elapsed system time in micro-seconds */
};

/* 
 * C library externs.
 */
extern "C" int    getrusage(int, struct rusage*);
extern "C" int    gettimeofday(struct timeval*, struct timezone*);

#endif _timer
