#define EQ_LINK_LIST_SIZE	1000
#define POINTS_TO_ME_SIZE	100

extern int	indent_value ;

STATUS link_eq_classes (eqci1, eqci2)
int	eqci1, eqci2 ;
{
    EQ_CLASS		eq_class_ptr1 = eq_class_table[eqci1].eq_ptr, 
			eq_class_ptr2 = eq_class_table[eqci2].eq_ptr;
    LOG_EXPR_LIST_ELEM	*temp_lele1, *temp_lele2, *lele_to_check, 
			loop_over[MAX_LELE] ;
    int			link_eq_list[EQ_LINK_LIST_SIZE][2], 
			link_eq_list_count = 0;
    STATUS 		error ;

   /* Other nodes might point to first entry in equivalence class
      being coalesced. */
    lele_to_check = eq_class_ptr2 -> log_expr_list.first ;

   /* Change equivalence class index on nodes in coalesced 
      equivalence class. */
    for (temp_lele2 = eq_class_ptr2 -> log_expr_list.first;
         temp_lele2 != NULL; temp_lele2 = temp_lele2 -> next) 
    {
	temp_lele2 -> eq_class_index = eqci1 ;
    }

   /* First node in coalesced class should point back to last 
      node in combining class. */
    eq_class_ptr2 -> log_expr_list.first -> prev 
	=  eq_class_ptr1 -> log_expr_list.last ;

   /* Last node in 'receiving' equivalence class should now point to 
      first node of coalesced eq. class. */
    eq_class_ptr1 -> log_expr_list.last -> next 
		= eq_class_ptr2 -> log_expr_list.first ; 

   /* Adjust last pointer in combining class to point to last node in
      coalesced class. */ 
    eq_class_ptr1 -> log_expr_list.last = eq_class_ptr2 -> log_expr_list.last ; 

   /* Loop over all equivalence classes. */
    for (i = eq_class_count + 1; --i >= 0;)
    {
	int	loop_count, k ;
       /* Change any pointer to coalesced equivalence class to
		  the combining equivalence class. */
	if (eq_class_table[i].eq_ptr == eq_class_ptr2)
	    eq_class_table[i].eq_ptr = eq_class_ptr1 ;

	loop_count = 0 ;
        for (temp_lele2 = eq_class_table[i].eq_ptr -> log_expr_list.first;
             temp_lele2 != NULL;
             temp_lele2 = temp_lele2 -> next)
	{
	    if (loop_count == MAX_LELE)
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }
	    loop_over[loop_count] = temp_lele2 ;
	    ++loop_count ;
	}
	

       /* Loop over all nodes in equivalence class. */
	for (k = -1;
	     ++k < loop_count && lele_to_check -> ref_count > 0;)
	{
	    LOG_EXPR		temp_log_expr ;
	    int 		j ;
	    BOOLEAN		ref_found, log_expr_used ;
	    long 		old_hash_bucket, new_hash_bucket ;
	    LOG_EXPR_LIST_ELEM	*ret_lele ;

	    ref_found = FALSE ;
	    log_expr_used = FALSE ;
	    temp_lele2 = loop_over[k] ;

	    for (j = MAX_OPERATOR_ARITY; --j >= 0;)
	    {
	       /* Check if node's input points to first node of 
		  coalesced equivalence class. */
		if (temp_lele -> expr.input[j] == lele_to_check)
		{
		   /* Form a temporary logical expression. */
		    if (log_expr_used == FALSE)
		    {
			init_log_expr (&temp_log_expr) ;
			temp_log_expr.my_operator = temp_lele -> expr.my_operator ;
			copy_operator_arg (&(temp_log_expr.argument),
					   &(temp_lele -> expr.argument)) ;
			hash_fct (temp_lele -> expr, old_bucket) ;
			log_expr_used = TRUE ;
		    }

		    ref_found = TRUE ;
		   /* Set new input to point to first node in combining
		      equivalence class. */
		    temp_log_expr.input[j] = 
			eq_class_ptr1 -> log_expr_list.first ;
		}
		else
		    temp_log_expr.input[j] = temp_lele -> expr.input[j] ;
	    } 

	   /* If a reference to first node of coalesced class was found, check
	      if 'new' expression already exists. */
	    if (ref_found == TRUE)
	    {
	       /* Look for 'new' expression. */
		CALL (find_log_expr (&temp_log_expr, (int) -1,
			    (LOG_EXPR_LIST_ELEM *) NULL,
			    &ret_lele)) ;

               /* If 'new' expression already exists ... */
		if (ret_lele)
		{
		   /* if 'new' expression is not in the coalesced 
		      equivalence class ... */
		    if (ret_lele -> eq_class_index != eqci2)
		    {
		       /* if 'new' expression is in combining equivalence class ... */
			if (ret_lele -> eq_class_index == eqci1)
			{
			    BOOLEAN	deleted ;
			   /* delete whichever is not first expression in the list. */
			    if (temp_lele == eq_class_ptr1 -> log_expr_list.first)
			    {
				CALL (delete_safe_log_expr_list_elem (ret_lele,
								&deleted)) ;
				if (deleted == FALSE)
				{
				    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
				}
			    }
			    else
			    {
				CALL (delete_safe_log_expr_list_elem (temp_lele, 
								&deleted)) ;
				if (deleted == FALSE)
				{
				    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
				}
			    }
			} 
		       /* new expression is in a different equivalence class */ 
			else
			{
			   .. delete temp_lele if not first expr., etc. 
			    EQ_CLASS	*temp_eq_class ;
			    get_eq_class_addr (temp_lele -> eq_class_index,
					       &temp_eq_class) ;
			    if (temp_lele != temp_eq_class -> log_expr_list.first) 
			    {
				BOOLEAN	deleted ;
				CALL (delete_safe_log_expr_list_elem (temp_lele,
								&deleted)) ;
				if (deleted == FALSE)
				{
				    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
				}
			    }
			    else
			    {
					
			    }
			    
			    get_eq_class_addr (ret_lele -> eq_class_index,
					       &temp_eq_class) ;
			    if (temp_eq_class -> trans_flag != TRANSFORMATIONS_IN_PROGRESS)
			    {
				++link_eq_list_count ;

				if (link_eq_list_count == EQ_LINK_LIST_SIZE)
				{
				    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
				}

				link_eq_list[link_eq_list_count][0] = eqci1 ;
				link_eq_list[link_eq_list_count][1] 
				    = ret_lele -> eq_class_index ;
			    }
			}
		    }
		}
		else
		{
		    for (j = MAX_OPERATOR_ARITY; --j >= 0;)
		    {
			if (temp_lele -> expr.input[j] == lele_to_check)
			{
			    temp_lele -> expr.input[j] 
				= eq_class_ptr1 -> log_expr_list.first ;
			    ++ (eq_class_ptr1 -> log_expr_list.first 
					      -> ref_count) ;
			    -- (lele_to_check -> ref_count) ;
			}	
		    }
		    hash_fct (temp_lele -> expr, new_bucket) ;
		    if (old_bucket != new_bucket)
		    {
			rehash (temp_lele, new_bucket) ;
		    }
				    
		} /* else */
	    } /* if ref_found == TRUE */

	} /* for all nodes in an equivalence class */
    } /* for all equivalence classes */
		 
   /* Deallocate coalesced equivalence class. */
    bzero ((char *) eq_class_ptr2, (int) sizeof (EQ_CLASS)) ;
    deallocate (eq_class_ptr2) ;

   /* if discovered any other needed merges, do 'em. */
    for (i = -1; ++i < link_eq_list_count;)
    {
	CALL (link_eq_classes (link_eq_list[i][0],
				link_eq_list[i][1])) ;
    }
    
    return (OKAY) ;
}

STATUS delete_safe_log_expr_list_elem (lele, deleted) ;
LOG_EXPR_LIST_ELEM	*lele ;
BOOLEAN			*deleted ;
{
    EQ_CLASS	*temp_eq_class ; 
    get_eq_class_addr (lele -> eq_class_index, &temp_eq_class) ;

    if (lele -> ref_count > 0)
    {
	*deleted = FALSE ;
	return (OKAY) ;
    }

    delete_log_expr_list_elem (lele) ;
    
    if (temp_eq_class -> log_expr_list.first == NULL)
    {
	bzero ((char *) temp_eq_class, (int) sizeof (EQ_CLASS)) ;
	eq_class_table[temp_eq_class -> eq_class_index].eq_ptr = NULL ;
	eq_class_table[temp_eq_class -> eq_class_index].flag = EMPTY ;
	deallocate (temp_eq_class) ;
    }
    
    *deleted = TRUE ;

    return (OKAY) ; 
}

STATUS get_query (lele, query)
LOG_EXPR_LIST_ELEM	*lele ;
QUERY			**query ;
{
    STATUS	error ;
    REG	int	i ;

    if (lele == NULL)
    {
        *query = NULL ;
        return (OKAY) ;
    }

    allocate_query (*query) ;
    (*query) -> my_operator = lele -> expr.my_operator ;
    copy_operator_arg (&((*query) -> argument), &(lele -> expr.argument)) ;

    for (i = opt_arity[(int) ((*query) -> my_operator)]; --i >= 0; )
    {
        QUERY	*query2 ;
        CALL (get_query (lele -> expr.input[i],
               &query2)) ;
        (*query) -> input[i] = query2 ;
    }

    return (OKAY) ;

}

STATUS free_query (query)
QUERY	*query ;
{
    REG int	i;

    if (query == NULL) return ;

    for (i = MAX_OPERATOR_ARITY;  --i >= 0;  )
        if (query->input [i] != NULL)
            free_query (query->input [i]);
    free ((char *) query);

    return (OKAY) ;

}
 
BOOLEAN exists_in_subtree (lele, op, op_arg)
LOG_EXPR_LIST_ELEM	*lele ;
OPERATOR		op ;
OPERATOR_ARGUMENT	*op_arg ;
{
    int			count = 0, i ;
    COMPARE		compare_arg ; 
    LOG_EXPR_LIST_ELEM 	*temp_lele  ;

    if (lele == NULL)
	return (FALSE) ;

    for (temp_lele = lele; temp_lele != NULL; temp_lele = temp_lele -> next)
    {
	if (op == temp_lele -> expr.my_operator)
	{
	    if (op_arg != NULL)
	    {
		compare_operator_args (&(temp_lele -> expr.argument),
				       &(temp_lele -> expr.my_operator),
				       op_arg,
				       &op,
				       &compare_arg) ;
		if (compare_arg == EQUAL_TO)
		    return (TRUE);
				    
	    }
	    else
		return (TRUE) ;
	}

	for (i = -1; ++i < opt_arity[(int) (temp_lele -> expr.my_operator)];)
	    if (lele -> expr.input != NULL)
	    {
		BOOLEAN	check ;
		check = exists_in_subtree (lele -> expr.input[i], op, op_arg) ;
		if (check == TRUE)
		    return (TRUE) ;
	    }
    }

    return (FALSE) ;
   
}

