/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/opt_util.c,v 1.16 92/11/18 01:32:56 bill Exp Locker: bill $ 
*
*/ 
 
#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "expr_str.h"
#include "global.h"

extern int 		opt_arity[] ;
extern TRACE 		trace ;
extern int 		indent_value ;

#if defined(__cplusplus) || defined (ANSI)
extern char     *error_text (int) ;
STATUS check_log_prop (STORAGE_SEG_ANCHOR *,
    LOG_EXPR_LIST_ELEM *,
    EQ_CLASS *,
    LOGICAL_PROPERTY **) ;
STATUS check_sys_prop (STORAGE_SEG_ANCHOR *,
    LOG_EXPR_LIST_ELEM *,
    EQ_CLASS *,
    SYSTEM_PROPERTY **) ;
STATUS derive_log_prop(OPERATOR,OPERATOR_ARGUMENT *,
    LOGICAL_PROPERTY **, 
    LOGICAL_PROPERTY *) ;
STATUS derive_sys_prop(OPERATOR,OPERATOR_ARGUMENT *,
    SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **,
    SYSTEM_PROPERTY *) ;
#else
extern char     *error_text () ;
STATUS check_log_prop () ;
STATUS check_sys_prop () ;
STATUS derive_log_prop() ;
STATUS derive_sys_prop() ;
#endif


/*
STATUS compare_sys_props (sp1, sp2, result)
SYSTEM_PROPERTY *sp1, *sp2 ;
COMPARE *result ;
{
    STATUS error ;

    if (sp1 == NULL || sp2 == NULL)
	FAIL (ERR_NULL_POINTER) ;

    if ((sys_prop_not_set(sp1)) || (sys_prop_not_set(sp2)))
	FAIL (ERR_NOT_INITIALIZED) ;

    if (((sp1 -> cardinality) == (sp2 -> cardinality)) &&
	((sp1 -> record_width) == (sp2 -> record_width)))
	*result = EQUAL_TO ;
    else
	*result = NOT_EQUAL_TO ;

    return (OKAY) ;

}
*/

#if defined(__cplusplus) || defined (ANSI)
STATUS check_log_prop (	STORAGE_SEG_ANCHOR *ssa, 
			LOG_EXPR_LIST_ELEM *lele, 
			EQ_CLASS *eq_class, 		
			LOGICAL_PROPERTY **ret_log_prop) 
#else
STATUS check_log_prop (ssa, lele, eq_class, ret_log_prop)
STORAGE_SEG_ANCHOR	*ssa ;
LOG_EXPR_LIST_ELEM	*lele ;
EQ_CLASS		*eq_class ;
LOGICAL_PROPERTY	**ret_log_prop ;
#endif
{
    EQ_CLASS		*ret_eq_class = eq_class ;
    int 		i, num_inputs ;
    LOGICAL_PROPERTY	*input_log_prop[MAX_OPERATOR_ARITY] ;
    STATUS		error ;

#if DEBUG>=2
#if defined(__cplusplus) || defined (ANSI)
    STATUS print_log_expr_list_elem (LOG_EXPR_LIST_ELEM *,
                                BOOLEAN) ;
#else
    STATUS print_log_expr_list_elem () ;
#endif
#endif

#if SAFETY>=1
    if (!lele)
	FAIL (ERR_NULL_POINTER) ; 

    if (!ssa)
	FAIL (ERR_NULL_POINTER) ; 

    if (!ret_log_prop)
	FAIL (ERR_NULL_POINTER) ; 
#endif

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("in check_log_prop: expression is:\n") ;
	CALL (print_log_expr_list_elem (lele, TRUE)) ;
    }
#endif

    if (ret_eq_class == NULL)
	get_eq_class_addr (ssa, lele -> eq_class_index, &ret_eq_class) ;

    if (logical_prop_not_set (&(ret_eq_class -> logical_property)))
    {
	num_inputs = opt_arity[(int) (lele -> expr.my_operator)] ;
	for (i = -1; ++i < num_inputs; )
	{
	    CALL (check_log_prop (ssa, lele -> expr.input[i],
					 (EQ_CLASS *) NULL,
					 &input_log_prop[i])) ;
	}
	
#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("calling derive_log_prop:\n") ;
    }
#endif
	CALL (derive_log_prop (lele -> expr.my_operator,
				&(lele -> expr.argument),
				&(input_log_prop[0]),
				&(ret_eq_class -> logical_property))) ;
#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("returned from derive_log_prop:\n") ;
    }
#endif
    }

    *ret_log_prop = &(ret_eq_class -> logical_property) ;

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("derived log. props are:\n") ;
	print_logical_prop (*ret_log_prop ) ;
	printi ("exiting check_log_prop.\n") ;
    }
#endif

    return (OKAY) ;
}

#if defined(__cplusplus) || defined (ANSI)
STATUS check_sys_prop (	STORAGE_SEG_ANCHOR *ssa, 
			LOG_EXPR_LIST_ELEM *lele, 
			EQ_CLASS *eq_class, 
			SYSTEM_PROPERTY **ret_sys_prop)
#else
STATUS check_sys_prop (ssa, lele, eq_class, ret_sys_prop)
STORAGE_SEG_ANCHOR	*ssa ;
LOG_EXPR_LIST_ELEM	*lele ;
EQ_CLASS		*eq_class ;
SYSTEM_PROPERTY		**ret_sys_prop ;
#endif
{
    EQ_CLASS		*ret_eq_class = eq_class ;
    int 		i, num_inputs ;
    SYSTEM_PROPERTY	*input_sys_prop[MAX_OPERATOR_ARITY] ;
    LOGICAL_PROPERTY	*input_log_prop[MAX_OPERATOR_ARITY] ;
    EQ_CLASS		*input_eq_class ;
    STATUS		error ;
#if DEBUG>=2
#if defined(__cplusplus) || defined (ANSI)
    STATUS print_log_expr_list_elem (LOG_EXPR_LIST_ELEM *,
                                BOOLEAN) ;
#else
    STATUS print_log_expr_list_elem () ;
#endif
#endif

#if SAFETY>=2
    if (!lele)
	FAIL (ERR_NULL_POINTER) ; 

    if (!ssa)
	FAIL (ERR_NULL_POINTER) ; 

    if (!ret_sys_prop)
	FAIL (ERR_NULL_POINTER) ; 
#endif

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("in check_sys_prop: expression is:\n") ;
	CALL (print_log_expr_list_elem (lele, TRUE)) ;
    }
#endif

    if (ret_eq_class == NULL)
	get_eq_class_addr (ssa, lele -> eq_class_index, &ret_eq_class) ;

    if (sys_prop_not_set (&(ret_eq_class -> system_property)))
    {
	num_inputs = opt_arity[(int) (lele -> expr.my_operator)] ;
	for (i = -1; ++i < num_inputs; )
	{
	    CALL (check_sys_prop (ssa, lele -> expr.input[i],
					 (EQ_CLASS *) NULL,
					 &input_sys_prop[i])) ;

	    get_eq_class_addr (ssa, lele -> expr.input[i] -> eq_class_index, 
				&input_eq_class) ;
	    input_log_prop[i] = &(input_eq_class -> logical_property) ;

	    if (logical_prop_not_set (input_log_prop[i])) 
	    {
		printi ("Logical properties not set for input %d.\n", i) ;
		FAIL (ERR_NOT_INITIALIZED) ;
	    }

	}
	
	CALL (derive_sys_prop (lele -> expr.my_operator,
				&(lele -> expr.argument),
				&(input_sys_prop[0]),
				&(input_log_prop[0]),
				&(ret_eq_class -> system_property))) ;

    }

    *ret_sys_prop = &(ret_eq_class -> system_property) ;

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("exiting check_sys_prop.\n") ;
    }
#endif

    return (OKAY) ;
}

