/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/vol_opt.c,v 1.16 92/11/18 01:32:49 bill Exp Locker: bill $ 
*
*/ 
 
#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "expr_str.h"
#include "global.h"

int	indent_value = 0 ;

#if defined(__cplusplus) || defined (ANSI)
extern char     *error_text (int) ;
STATUS find_log_expr_list_elem (STORAGE_SEG_ANCHOR *,
                                LOG_EXPR *,
                                int,
                                LOG_EXPR_LIST_ELEM *,
                                LOG_EXPR_LIST_ELEM **) ;
STATUS get_rule_group_ssa (int, STORAGE_SEG_ANCHOR **) ;
STATUS insert_log_expr (STORAGE_SEG_ANCHOR *,
                        LOG_EXPR *,
                        int,
                        int *,
                        LOG_EXPR_LIST_ELEM **,
                        BOOLEAN) ;
STATUS transform_query (QUERY *, LOG_EXPR_LIST_ELEM **,
                        int, STORAGE_SEG_ANCHOR **) ;
static STATUS transform_phy_expr_list_elem (STORAGE_SEG_ANCHOR *,
  PHY_EXPR_LIST_ELEM *, PLAN **) ;
extern STATUS find_best_plan ( LOG_EXPR *,
                        LOG_EXPR_LIST_ELEM *,
                        PROPERTY_VECTOR *,
                        PV_COMPARE,
                        PROPERTY_VECTOR *,
                        PV_EXCL_COMPARE,
                        COST *,
                        int,
                        EQ_CLASS *,
                        int,
                        STORAGE_SEG_ANCHOR *,
                        OPT_RETURN *) ;
extern STATUS print_phy_expr_list_elem (PHY_EXPR_LIST_ELEM *) ;
#if defined (PRINT_OUTPUT) && defined (GET_STATS) 
extern STATUS get_hash_stats (STORAGE_SEG_ANCHOR *,
                       BOOLEAN, long *) ;
extern STATUS get_eq_class_stats (STORAGE_SEG_ANCHOR *,
                                BOOLEAN, long *,
                                long *) ;
extern STATUS count_expressions(STORAGE_SEG_ANCHOR *, EQ_CLASS *,
    double *, int *) ;
#endif
STATUS generate_all_transformations (LOG_EXPR_LIST_ELEM *, int,
                                     STORAGE_SEG_ANCHOR *) ;
#if defined (DUMP_ON_ABEND) && defined (PRINT)
STATUS dump_storage () ;
extern STATUS print_log_expr (LOG_EXPR *, BOOLEAN) ;
extern STATUS print_query (QUERY *) ;
#endif
#else
extern char* malloc () ;
extern char     *error_text () ;
STATUS find_log_expr_list_elem () ;
STATUS get_rule_group_ssa () ;
STATUS insert_log_expr () ;
STATUS transform_query () ;
static STATUS transform_phy_expr_list_elem () ;
extern STATUS print_phy_expr_list_elem () ;
extern STATUS print_log_expr () ;
extern STATUS print_query () ;
STATUS generate_all_transformations () ;
#if defined (PRINT_OUTPUT) && defined (GET_STATS) 
extern STATUS get_hash_stats () ;
extern STATUS get_eq_class_stats () ;
extern STATUS count_expressions() ;
#endif
#if defined (DUMP_ON_ABEND) && defined (PRINT)
STATUS dump_storage () ;
#endif
#endif

#if DEBUG>=1
TRACE 				trace = TRACE_ON ;
int				level = -1 ;
#endif
extern STORAGE_SEG_ANCHOR	**base_ssa_table ;
extern int                     	ss_count ;

extern int 		opt_arity[] ;
extern int 		algo_arity[] ;
extern int		storage_initialized ;

#ifdef GET_STATS	
int			num_reallocs = 0 ;
extern COST		first_plan_cost ;
extern BOOLEAN          plan_yet ;
int			num_mallocs = 0 ;
int			num_frees = 0 ;
#endif

/* This is the optimizer called by the DBMS. */ 

#if defined(__cplusplus) || defined (ANSI)
STATUS volcano_optimizer (QUERY *query, PROPERTY_VECTOR *prop_vec, 
			 PV_COMPARE pv_compare_value,
		         PROPERTY_VECTOR *excl_prop_vec, 
			 PV_EXCL_COMPARE pv_excl_compare_value,
			 COST *cost_limit, PLAN **plan) 
#else
STATUS volcano_optimizer (query, prop_vec, pv_compare_value,
		         excl_prop_vec, pv_excl_compare_value,
			 cost_limit, plan) 
QUERY 			*query ;
PROPERTY_VECTOR		*prop_vec ;
PROPERTY_VECTOR		*excl_prop_vec ;
PV_EXCL_COMPARE		pv_excl_compare_value ;
PV_COMPARE		pv_compare_value ;
COST			*cost_limit ;
PLAN			**plan ;
#endif
{
    LOG_EXPR_LIST_ELEM 	*lele ;
    OPT_RETURN		opt_return ;	
    STATUS 		error, opt_error ;
    STORAGE_SEG_ANCHOR	*ssa ;
#if defined(GET_STATS) && defined(PRINT_OUTPUT) 
    long		hash_chain_total = 0 ;
    long		log_expr_total = 0 ;
    long		phy_expr_total = 0 ;
#endif
#if SAFETY>=2
    long		eq_class_total = 0 ;
#ifdef GET_STATS	
    double		number_expressions ;
    int			max_ref_count = 0 ;
#endif
    EQ_CLASS		*eq_class ;
#endif
    int			rule_group = DEFAULT ;



    init_opt_return (&opt_return) ;

    ssa = NULL ;

/********************** SIL ************************************
        system (" echo before transform query  ; ps -l | grep t4");
******************  BURAYA KADAR ****************************/

    CALL (transform_query (query, &lele, rule_group, &ssa)) ;

/********************** SIL ************************************
        system (" echo after transform query ; ps -l | grep t4");
******************  BURAYA KADAR ****************************/


    ssa -> original_lele = lele ;

   /* Find best plan. */
   
    CALL (find_best_plan (
		&(lele -> expr), lele,
		prop_vec, pv_compare_value,
		excl_prop_vec, pv_excl_compare_value,
		cost_limit, 
		lele -> eq_class_index, 
		ssa -> base_eq_class_table[lele -> eq_class_index].eq_ptr,
		rule_group,
		ssa,
		&opt_return)) ;

/********************** SIL ************************************
        system (" echo after fbp  ; ps -l | grep t4");
******************  BURAYA KADAR ****************************/


    opt_error = error ;

#ifdef PRINT_OUTPUT
#ifdef GET_STATS	
    printi ("Calls to optimize       = %d\n", ssa -> calls_to_optimize) ;
    printi ("Calls to find_best_plan = %d\n", ssa -> calls_to_fbp) ;
    printi ("Number of mallocs       = %d\n", num_mallocs) ;
    printi ("Calls to frees          = %d\n", num_frees) ;
    printi ("Number of reallocs (rule info.) = %d\n", num_reallocs) ;
    printi ("EQ. class count = %d\n", ssa -> eq_class_count) ;
    CALL (get_hash_stats (ssa, FALSE, &hash_chain_total)) ;
    CALL (get_eq_class_stats (ssa, FALSE, &log_expr_total, &phy_expr_total)) ;
#if SAFETY>=2
/*
    CALL (check_storage (&(ssa -> eq_class_total))) ;
    if (eq_class_total != hash_chain_total)
    {
	printi ("hash_chain_total = %ld, eq_class_total = %ld\n",
		 hash_chain_total, eq_class_total) ;
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    }
*/
    get_eq_class_addr (ssa, lele -> eq_class_index, &eq_class) ;
    count_expressions (ssa, eq_class, &number_expressions, &max_ref_count) ;
    printf ("Equivalent forms   : %.0lf\n", 
		number_expressions) ;
    printf ("Max. reference count = %d\n", max_ref_count) ;
#endif
    printi ("Total number of logical algebra nodes = %ld\n", hash_chain_total) ;
    printi ("Total number of physical algebra nodes = %ld\n", phy_expr_total) ;
    if (hash_chain_total != log_expr_total) 
    {
	FAIL (ERR_SANITY_CHECK) ;
    }
#endif
    if (opt_error == OKAY)
    {
	printi ("Optimization successful.\n") ;
#ifdef PRINT
/********* COMMENT I SIL *******
	printi ("Returned stored physical expression:\n") ;
	CALL (print_phy_expr_list_elem (opt_return.pele)) ;
*********************************/
#endif
    }
#endif

#ifdef DEMO
#ifdef GET_STATS
    {
	EQ_CLASS 	*top_eq_class ;
	int 		ref_count ;
	double		num_exprs ;
	get_eq_class_addr (ssa, lele -> eq_class_index, &top_eq_class) ;
	count_expressions (ssa, top_eq_class, &num_exprs, &ref_count) ;
	printf ("Equivalent forms   : %.0lf\n", num_exprs) ;
    }
#endif
#endif

#ifdef DUMP_ON_ABEND
#ifdef PRINT
    if (opt_error != OKAY)
    {
	printi ("Optimization failed.\n") ;
	CALL (dump_storage ()) ;
    }
#endif
#endif

   /* Transform resulting physical expression into a 'plan'. */
    if (opt_error == OKAY)
	CALL (transform_phy_expr_list_elem (ssa, opt_return.pele, plan)) ;

    return (opt_error) ;

}

/*-----------------------------------------------------------------*/

#if defined(__cplusplus) || defined (ANSI)
static STATUS transform_phy_expr_list_elem (STORAGE_SEG_ANCHOR *ssa, 
  PHY_EXPR_LIST_ELEM *pele, PLAN **plan)
#else
static STATUS transform_phy_expr_list_elem (ssa, pele, plan)
STORAGE_SEG_ANCHOR	*ssa ;
PHY_EXPR_LIST_ELEM 	*pele ;
PLAN			**plan ;
#endif
{
    PLAN	*temp_plan ;
    EQ_CLASS	*eq_class ;
    int		i ;
    STATUS 	error ;

   /* If 'leaf' of phy. expr. tree, return NULL. */
    if (pele == NULL)
    {
        *plan = NULL ;
	return (OKAY) ; 
    }

    if (pele -> expr -> plan != NULL)
    {
	*plan = pele -> expr -> plan ;
	return (OKAY) ;
    }

    if (pele -> lele == NULL)
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;

    allocate_plan (temp_plan) ;
    pele -> expr -> plan = temp_plan ;

    temp_plan -> algorithm = pele -> expr -> algorithm ;
    copy_algorithm_arg (&(temp_plan -> algorithm_argument), 
		     &(pele -> expr -> algorithm_argument)) ;
    temp_plan -> my_operator = pele -> lele -> expr.my_operator ;
    copy_operator_arg (&(temp_plan -> operator_argument), 
		     &(pele -> lele -> expr.argument)) ;
    copy_cost (&(temp_plan -> cost), &(pele -> expr -> cost)) ;
    copy_property_vec (&(temp_plan -> property_vector),
			  &(pele -> property_vector)) ; 
    copy_property_vec (&(temp_plan -> excl_property_vector),
			  &(pele -> excl_property_vector)) ; 
    get_eq_class_addr (ssa, pele -> eq_class_index, &eq_class) ;
    copy_logical_prop (&(temp_plan -> logical_property), 
		   &(eq_class -> logical_property)) ;
    copy_sys_prop (&(temp_plan -> system_property),
		   &(eq_class -> system_property)) ;

   /* Loop over operator inputs. */
    for (i = MAX_ALGORITHM_ARITY; --i >= 0; )
    {
        PLAN *plan2 ;
	if (pele -> expr -> input[i] == NULL)
	    continue ;
       /* Recursively transform inputs. */
        CALL (transform_phy_expr_list_elem (ssa, pele -> expr -> input[i],
	       &plan2)) ;
	temp_plan -> input[i] = plan2 ; 
    }

   /* Return the address of the logical expression */
   /* list element.				   */ 
    *plan = temp_plan ;

    return (OKAY) ;

} /*transform_phy_expr_list_elem */

/*-----------------------------------------------------------------*/

/* Transform query into storage structure format and        */
/* returns pointer to node containing log. expr. equivalent */
/* to query.                                                */

#if defined(__cplusplus) || defined (ANSI)
STATUS transform_query (QUERY *query, LOG_EXPR_LIST_ELEM **lele, 
		        int rule_group, STORAGE_SEG_ANCHOR **ssa)
#else
STATUS transform_query (query, lele, rule_group, ssa)
QUERY 			*query ;
LOG_EXPR_LIST_ELEM 	**lele ;
int			rule_group ;
STORAGE_SEG_ANCHOR  	**ssa ;
#endif
{
    LOG_EXPR 		le ;
    int 		ret_eq_class_index ;
    LOG_EXPR_LIST_ELEM 	*ret_lele ;
    int 		i ;
    EQ_CLASS		*temp_eq_class ;
    STATUS 		error ;
#if SAFETY>=2
    COMPARE		compare ;
#endif

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("transform_query called.\n") ;
    }
#endif
    if (ssa == NULL)
    {
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    }

    if (*ssa == NULL)
    {

#if DEBUG>=2
        if (trace == TRACE_ON)
	{
	    printi ("Getting storage structure anchor for rule group.\n") ;
	}
#endif

	CALL (get_rule_group_ssa (rule_group, ssa)) ;

#if DEBUG>=2
	if (trace == TRACE_ON)
	{
	    printi ("Storage structure anchor for rule group returned.\n") ;
	    printi ("Transforming query.\n") ;
	}
#endif

	(*ssa) -> calls_to_optimize = 0 ;
	(*ssa) -> calls_to_fbp = 0 ;

    }

   /* If 'leaf' of query tree, return NULL. */
    if (query == NULL)
    {
#if DEBUG>=2
	if (trace == TRACE_ON)
	{
	    printi ("Query node null. Returning.\n") ;
	}
#endif
        *lele = NULL ;
	return (OKAY) ; 
    }

   /* Initialize logical expression. */
    init_log_expr (&le) ;

   /* Set operator and copy operator argument. */
#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("Setting operator and copying argument.\n") ;
    }
#endif
    le.my_operator = query -> my_operator ;
    copy_operator_arg (&(le.argument), &(query -> argument)) ;

#if SAFETY>=2
    CALL (compare_operator_args (&(le.argument), &(le.my_operator),
			   &(query -> argument),
			   &(query -> my_operator), &compare)) ; 
    if (compare != EQUAL_TO)
    {
	print_operator_arg (&(le.argument), &(le.my_operator)) ;
	print_operator_arg (&(query -> argument), &(query -> my_operator)) ; 
	FAIL (ERR_SANITY_CHECK) ;
    }
#endif

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("Returned from copying argument.\n") ;
    }
#endif

   /* Loop over operator inputs. */
    for (i = opt_arity[(int) (query -> my_operator)]; --i >= 0; )
    {
        LOG_EXPR_LIST_ELEM *lele2 ;
       /* Recursively transform inputs. */
#if DEBUG>=2
	if (trace == TRACE_ON)
	{
	    printi ("Calling transform query on input %d.\n", i) ;
	}
#endif
        CALL (transform_query (query -> input[i],
	       &lele2, rule_group, ssa)) ;
	le.input[i] = lele2 ; 
    }

   /* Check for initial common subexpression. */
#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("Checking for initial common subexpression.\n") ;
    }
#endif
    CALL (find_log_expr_list_elem (*ssa, &le, (int) -1,
		(LOG_EXPR_LIST_ELEM *) NULL,
		&ret_lele)) ;

   /* If not common subexpression, add it. */
    if (ret_lele == NULL)
    {
       /* Insert this expression into the storage structure.   */
       /* FALSE flag means do not search storage structure to  */
       /* see if expression already exists there. -1 indicates */
       /* that this expression is not a member of an existing  */
       /* equivalence class.                                   */
#if DEBUG>=2
        if (trace == TRACE_ON)
	{
	    printi ("Not common subexpression, will insert.\n") ;
	}
#endif
	CALL (insert_log_expr (*ssa, &le, (int) -1,
				&ret_eq_class_index,
				&ret_lele, FALSE)) ;
#if DEBUG>=2
	if (trace == TRACE_ON)
	{
	    printi ("Calling generate_all_transformations.\n") ;
	}
#endif
	CALL (generate_all_transformations (ret_lele, rule_group, *ssa)) ;	

    }

   /* Return the address of the logical expression */
   /* list element.				   */ 
    get_eq_class_addr (*ssa, ret_lele -> eq_class_index, &temp_eq_class) ;
    *lele = temp_eq_class -> log_expr_list.first ;

    if (*lele == NULL)
    {
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    }

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("Returning from transform_query.\n");
    }
#endif

    return (OKAY) ;

} /*transform_query */

