
#include <stdio.h>
#include "linklist.h"
#include "keywords.h"

void AndTerm::setExp( LinkedList * anExp )
{
	andedExp = anExp;
}

void AndTerm::printOn()
{
	printf(" --------  AND TERM  ---------\n");
	if( andedExp ) andedExp->printOn();
	else printf( " Or ed term ler yok\n");
	if(dictItems) dictItems->printOn();
	else printf(" Dictionaryde bos \n");
	printf(" -----------------------------\n\n");
}

void AndTerm::extractTerms( ListItem * inItem)
{
        LinkedList      	*list;
	SortedStringList	*key;

        if(inItem->itemType != AND )
        {
                list = andedExp->subList( inItem->lastTerm, inItem );
		key = (SortedStringList *) list->extractVariables();
		(( Stack *) list)->stack2tree( list->lastItem );
		dictItems->add( key, list );
                return;
        }
        else
        {
                extractTerms( inItem->left );
                extractTerms( inItem->right );
        }
}



void DictItem::setKey( SortedStringList *inKey )
{
        key     = inKey;
}

void DictItem::addExp( LinkedList       *anExp)
{
        exp->insert( AND_TERM, VOID anExp);
}

void DictItem::printOn()
{
	printf("--------- DICT ITEM -------\n");
	printf(" KEY   : ");
	key->printOn();
	printf("\nEXP   : ");
	exp->printOn();
	printf("\n------------------\n\n");
}


void SortedStringList::printOn()
{
	LinkedList::printOn();
}


int SortedStringList::compare( SortedStringList* cmpKey)
{
        int     i=0;
        ListItem        *p, *q;
        if( size != cmpKey->size ) return 0;
        if( size == 0 || cmpKey->size == 0 ) return 0;
        p = firstItem;
        q = cmpKey->firstItem;
        while( p && q )
        {
#ifdef DEBUG
		printf(" COMPARED 1: %s     2 : %s \n",
				( char * ) p->item,
				( char * ) q->item);
#endif
                if(strcmp((char *) p->item, (char *) q->item) != 0 ) 
			return 0;
                p = p->next;
                q = q->next;
        }
#ifdef DEBUG
	printf(" BIRI AYNI DIYOR ");
#endif
        return 1;
}


void Dictionary::printOn()
{
	printf("\n ----- DICTIONARY ------\n");
	LinkedList::printOn();
	printf("------------------------\n\n");
}

void Dictionary::add( SortedStringList *inKey, LinkedList *andTerm )
{

        ListItem*       place;
        place = findPlace( inKey );
        if( place == NULL )
        {
                DictItem*       aDictItem;  
		aDictItem = new DictItem();
                aDictItem->setKey( inKey );
                aDictItem->addExp( andTerm);
                insert( BIND_AND_TERM, VOID aDictItem);
        }
        else {
                ( (DictItem *) place->item)->addExp( andTerm );
                delete inKey;
        }

}

ListItem *Dictionary::findPlace( SortedStringList *inKey )
{
        ListItem        *p;
        p   = firstItem;
        while(p)
        {
                if( inKey->compare( (( DictItem *) p->item)->key ))
		{
                        return p;
		}
                p = p->next;
        }
        return NULL;
}


