


/************************************************************************* 

			ABOUT THIS FILE 



Subject	:

	The member functions of ListItem, LinkedList, and Stack
	are declared in this file. 

Author 	: 

	Cetin Ertan Ozkan

Date	: 

	15/02/1993

Last Test Date :

	15/02/1993

Last Revision Date :

	No revision

Related Files :

	../include/linklist.h --> related class declaration

*************************************************************************/



/*************************************************************************



		DATA DEFINITION LANGUAGE PARSER ( MOODSQL ) 




It parses the following statements :

	0. BEGIN DECLARATIONS { ... };
	1. CREATE INDEX ...
	2. CREATE BINARY JOIN INDEX ...
	3. CREATE CLASS ...
	4. CREATE TYPE ...

and the following drop statements :

	1. DROP INDEX ...
	2. DROP BINARY JOIN INDEX ...
	3. DROP CLASS ...
	4. DROP TYPE ...


**************************************************************************/


#include "mood_parser.h"
#include "decldml.h"
#include "userreq.h"
#include "bplusddl.h"
#include "bjndxddl.h"
#include "classddl.h"
#include "index.h"


//	It parses the statements which begin with CREATE keyword
createStatements( UserRequest * ur )
{
        int     result;
	char	funcSpec = PUBLIC;
 
        ur->getToken();

	//printf("CCREATE STATE");
 
        switch(ur->tokenType())
        { 
                case MS_UNIQUE: 
		{ 
			ur->getToken();
                        if( ur->tokenType() != INDEX ){
                                    ur->setError( PARSE_ERROR, UNIQUE_KWD_ERROR, "" );
                                    break;
                        }
                        ur->backtrack();
                }
                case INDEX : 
		{
/*
                        IndexClass *iCreate = new IndexClass(ur);
                        result = iCreate->createIndexParser();
*/
                        break;
		}

 
                case TYPE   :
                case CLASS  :
		{
			DeclStmnt	*ds = new DeclStmnt( ur );
			ur->backtrack();
			result = ds->simpleParse();
                        break;
		}
 
                case BINARY :
		{
			BJIndexCreate *bjiCreate = new BJIndexCreate(ur);
			result = bjiCreate->parse();
                      break;
		}

		case DATABASE :
		{
			//CreateDatabaseClause
			CreateDatabase	*dbCreate = new CreateDatabase( ur );
			dbCreate->connectUserRequest();
			result = dbCreate->parse();
			break;
		}

		case PRIVATE  :
			funcSpec = PRIVATE;
		case PUBLIC   :
		{
			CreateFunction	*funcCreate = new CreateFunction( ur, funcSpec );
			funcCreate->connectUserRequest();
			result = funcCreate->parse();
			break;
		}

		case FUNCTION :
		{
			CreateFunction	*funcCreate = new CreateFunction( ur, funcSpec );
			funcCreate->connectUserRequest();
			ur->backtrack();
			result = funcCreate->parse();
			break;
		}
 
                default     :
                        ur->backtrack();
			ur->setError( PARSE_ERROR, UNKNOWN_SYNTAX,"");
                        result = FALSE;
        }
 
        return result;
 
}



// it parses the statements which begin with DROP keyword
dropStatements( UserRequest *ur )
{
	int 	result;

	ur->getToken();

        switch(ur->tokenType())
        { 
                case INDEX : 
		{
			IndexClass *iDrop = new IndexClass(ur);
                        result = iDrop->dropIndexParser();
                        break;
		}

                case TYPE   : 
		case CLASS  :
		{
			ClassDrop *cDrop = new ClassDrop( ur );
			cDrop->connectUserRequest();
			result =  cDrop->parse();		
			break;
		}

		case BINARY :
		{
			BJIndexDrop *bjiDrop = new BJIndexDrop(ur);
			result = bjiDrop->parse();
			break;
		}

		case DATABASE  :
		{
			DropDatabase	*dbDrop = new DropDatabase( ur );
			dbDrop->connectUserRequest();
			result = dbDrop->parse();
			break;
		}

		case FUNCTION :
		{
			DropFunction	*funcDrop = new DropFunction( ur );
			funcDrop->connectUserRequest();
			result = funcDrop->parse();
			break;
		}
 
                default     :            
                        ur->backtrack();
                        ur->setError( PARSE_ERROR, UNKNOWN_SYNTAX,"");
                        result = FALSE;

        }
 
        return result; 

}

