
#include <stdio.h>
#include "linklist.h"
#include "keywords.h"
#include "mood_parser.h"

extern void printPlan( QUERY * );
extern displayFID(FID *);
extern ListItem undefinedItem;
extern void freeQUERY( QUERY *);
extern void copyFunctionAtt( RELATION_SCHEMA *, RELATION_SCHEMA *);


void SubTreeItem::printOn()
{
	//printf(" tree item bind var : %s\n", bindVar );
}

void SubTreeList::printOn()
{
	ListItem	*p;
	for(p = firstItem; p; p=p->next ) ((SubTreeItem *) p->item)->printOn();
}

QUERY* SubTreeItem::isGeneratedMAT( char *pathStr )
{
	QUERY 	*p;
	for( p = top; p; p = p->input[0] )
		if( p->my_operator == MAT && !strcmp( pathStr, p->argument.mat.attr[0] ))
			return p;
	return NULL;
}


SubTreeItem *SubTreeList::findPlace( char *bindVar )
{
	ListItem	*p;
	for( p = firstItem; p; p = p->next )
		if( !strcmp( bindVar, (( SubTreeItem * ) p->item)->bindVar ))
			return ( (SubTreeItem *) p->item );
	return NULL;
}

void SubTreeList::generate( BindExpression *bexp, SortedStringList *aList )
{
#ifdef DEBUG
	printf(" SubTreeList::generate\n");
#endif
	QUERY		*currTree;
	ListItem	*p;
	SubTreeItem	*inItem;

	p = bexp->firstItem;
	while(p)
	{
		inItem = new SubTreeItem();
		strcpy( inItem->bindVar, ((BindListItem *) p->item)->alias );
		//currTree = new QUERY;
		currTree = (QUERY *) malloc( sizeof(QUERY) );
		currTree->my_operator = GET_SET;
		currTree->argument.get_set.use_self = FALSE;
		if( aList->firstItem ) 
		{
			ListItem	*nextItem;
			nextItem = aList->findPlace( inItem->bindVar );
			if( nextItem == &undefinedItem )
				currTree->argument.get_set.use_self = TRUE;
		}
		else currTree->argument.get_set.use_self = TRUE;
		strcpy( currTree->argument.get_set.attr, inItem->bindVar);
		currTree->input[0] = NULL;
		currTree->input[1] = NULL;
		((RELATION_SCHEMA) currTree->argument.get_set.input).copy(
			& (((BindListItem *) p->item)->classInfo ) );
		inItem->top = currTree;
#ifdef DEBUG
		printPlan( inItem->top );
#endif
		insert( VOID inItem );
		p = p->next;
	}
}

void PathItem::stack2tree()
{
	ListItem	*p;
	if( !parameters ) return;
	for( p = parameters->firstItem; p; p=p->next )
		((Expression *) p->item)->stack2tree(((Expression *)p->item)->lastItem);
}

void PathExpression::stack2tree()
{
	ListItem	*p;
	if( !pathItems ) return;
	for( p = pathItems->firstItem; p; p = p->next)
		((PathItem *) p->item)->stack2tree();
}


// It adjusts the left and right pointers of operatos in an expression
// to simplfy further operations
ListItem * Stack::stack2tree( ListItem *inItem)
// item at which the process begins
{
        ListItem        *p, *q;

	this->firstItem->prev = NULL;
 
        if( !inItem ) return NULL;

        switch(inItem->itemType){
		/* Handle Unary Operators */
                case NOT :
	//	case NOTNOT :
			inItem->left  = inItem->prev;
			inItem->right = NULL; 
			q = stack2tree( inItem->prev );
                        return q;
			break;

		/* Handle binary operators */ 
                case AND	:
		case OR 	:
		case EQ         :
                case NE         :
                case GE         :
                case LT         :
                case LE         :
                case GT         :
                case ISOP       :
                case ISNOT      :
          /*      case EEQ        :
                case ENE        :
                case EGE        :
                case ELT        :
                case ELE        :
                case EGT        :
                case EIS        :
                case EISNOT     :*/
		case ADD	:
		case MUL	:
		case DIV	:
		case SUB	:
			inItem->right = inItem->prev;
                        p = stack2tree(inItem->prev);
			inItem->left = p;
			if(!p) {
				printf("can not convert stack to tree");
				return NULL;
			}
			q = stack2tree(p);
			if( q) inItem->lastTerm = q->next;
			else {
				inItem->lastTerm = firstItem ;
				//printf(" LASTERM SIS NULL");
			}
                        return q;
			break;

		case PATH_EXP :
			//(( PathExpression *) inItem )->stack2tree();
			inItem->lastTerm = inItem;
			return( inItem->prev );
			
 
		/* for constants and variables */
                default:
			inItem->lastTerm = inItem;
                        return( inItem->prev );
        }
}


// this member function assumes that predicate is converted to the
// disjunctive normal form. Therefore the top of the stack must be
// an "OR" type. Then it extracts the the predicates which are connected
// with and "AND" operator. For the first call item parameter is the top
// of the stack
void Stack::extractAndedTerms( AndTerms *andList, ListItem *item )
{
	LinkedList 	*list;
	AndTerm		*aTerm;
	if(item->itemType != OR )
	{
		/*printf("\n ANDED TERMS \n");
		if(item) {
			printf("\n ITEM  : ");
			item->printOn();
			printf(" last of item : ");
			item->lastTerm->printOn();
		}
		printf("\n");*/
		list = subList( item->lastTerm, item );
		((Stack *) list)->stack2tree( list->lastItem );
		list->firstItem->prev = NULL;
		aTerm = new AndTerm();
		aTerm->setExp( list );
		aTerm->extractTerms( list->lastItem );
		andList->insert( VOID aTerm );
		//list->printOn();
		return;
	}
	else
	{
		extractAndedTerms( andList, item->left );
		extractAndedTerms( andList, item->right );
	}
}

QUERY *AndTerms::generateTree( SubTreeList *subTree,  ProjectionExpression *pList, UserRequest *ur )
// generate UNION here
{
	QUERY 		*ttop, *currTree;
	ListItem	*p;

#ifdef DEBUG
	printf("AndTerms::generateTree\n");
#endif

/**************  ADD UNIONS here *************************/

	ttop = ( ( AndTerm *) firstItem->item)->generateTree( subTree, pList, ur );
	if( ttop == (QUERY *) &undefinedItem ) goto error_handler_gen_tree;

	top = ttop;

/******************************
	if( p->next ) {
		ur->setError( RUNTIME_ERROR, R_VERSION_ERROR, "OR optimization");
		freeQUERY( top );
		top = NULL;
		return (QUERY *) &undefinedItem;
	}
******************************/
/*************
	for( p = firstItem->next; p; p=p->next ){
		ttop = ( ( AndTerm *) p->item)->generateTree( subTree, pList, ur );

		if( ttop == (QUERY *) &undefinedItem ) 
			goto error_handler_gen_tree;

		currTree = (QUERY *) malloc( sizeof(QUERY) );
		currTree->my_operator = UNION;
		currTree->input[0] = top ;
		currTree->input[1] = ttop ;
		top = currTree;
	}
*************/

#ifdef DEBUG
	if( !top ) printf(" AndTerms does not generate tree\n ");
#endif
	return top;

error_handler_gen_tree :
	// clean generated tree here
	freeQUERY( top );
	top = NULL;
	return (QUERY *) &undefinedItem;
}

QUERY *AndTerm::generateTree( SubTreeList *subTree, ProjectionExpression *pList, UserRequest *ur )
{
#ifdef DEBUG
	printf("AndTerm::generateTree\n");
#endif
	ListItem	*p;
	QUERY		*ttop;
	// generate MAT
	andedExp->generateMAT( subTree );

	// generate MAT for Projection Expression
	p = pList->firstItem;

	while(p)
	{
		((ProjectionListItem *) p->item)->projExpression->generateMAT(subTree);
		p = p->next;
	}

	// generate SELECT
	dictItems->generateSELECT( subTree );

	subTree->printOn();

	// later generate JOIN
	top = NULL;

	ttop = dictItems->generateJOIN( subTree, ur );
	if( ttop == (QUERY *) &undefinedItem ) goto error_handler_genTree; 
	
	if( ttop ) top = ttop;
	else top = ( ( SubTreeItem *) subTree->firstItem->item)->top;

#ifdef DEBUG
	if(!top) printf(" AndTerm does not generate tree \n ");
#endif
	return top;

error_handler_genTree :
	return (QUERY *) &undefinedItem;

}

JOIN_ARG *DictItem::generateJoinPred()
{
	JOIN_ARG	*ja, *tja1, *tja2;
	ListItem	*p;
	LinkedList	*ll;
	
	p = exp->firstItem;
	ll = (LinkedList *) p->item;
	tja1 = ll->convertToIlker( ll->lastItem );
	if( !p->next ) return tja1;

	p = p->next;
	ll = (LinkedList *) p->item;
	tja2 = ll->convertToIlker( ll->lastItem );
	//ja = new JOIN_ARG;
	ja = (JOIN_ARG *) myAlloc( sizeof( JOIN_ARG ) );
	ja->fcn = NULL;
	ja->left  = tja1;
	ja->right = tja2;
	ja->type  = OPER;
        ja->data.op = AND_OP;
	
	if( !p->next ) return ja;

	p = p->next;

	while(p)
	{
		ll = (LinkedList *) p->item;
		tja1 = ll->convertToIlker( ll->lastItem );
		tja2 = ja;
		//ja = new JOIN_ARG;
		ja = (JOIN_ARG *) myAlloc( sizeof( JOIN_ARG ) );
		ja->fcn = NULL;
		ja->left  = tja1;
		ja->right = tja2;
		ja->type  = OPER;
        	ja->data.op = AND_OP;
	}
	return ja;
}



#define MAXJOINNO 10


QUERY *Dictionary::generateJOIN( SubTreeList *subTree, UserRequest *ur )
// generate JOIN tree here
{
	ListItem *p;
	DictItem *di;
	SubTreeItem *sbi;
	QUERY *currTree;
	char bvLeft[40], bvRight[40], *bvi;
	int treeCnt, noOfJoins = 0, leftIndex, rightIndex;
	QUERY *joinTree[MAXJOINNO];
	SortedStringList *joinedVar[MAXJOINNO];
	JOIN_ARG *jarg;
	int	errorType = 1;
	int	checkCartesian = 0;
	
	// Search dictionary which is not processed and contains two
	// bind variable
	p = firstItem;
	currTree = NULL;

	while(p)
	{
		di = ( DictItem * ) p->item;

		// if it size greater than two and not processed
		if( di->key->size == 2 && ( !(di->isProcessed ))){

			// Determine the bind variables
			strcpy( bvLeft, ( char *) di->key->firstItem->item ); 
			strcpy( bvRight, ( char *) di->key->firstItem->next->item ); 

			di->isProcessed = TRUE;

			leftIndex  = MAXJOINNO + 1;
			rightIndex = MAXJOINNO + 1;

			for( treeCnt = 0; treeCnt < noOfJoins; treeCnt++ ){
				if( joinedVar[ treeCnt ]->hasMember( bvLeft ) ){	
					leftIndex = treeCnt;
					break;
				}
			}

			for( treeCnt = 0; treeCnt < noOfJoins; treeCnt++ ){
				if( joinedVar[ treeCnt ]->hasMember( bvRight ) ){
					rightIndex = treeCnt;
					break;
				}
			}

			// if there is no previously generated one
			if( leftIndex == MAXJOINNO + 1 && rightIndex == MAXJOINNO + 1 )
			{
				joinedVar[ noOfJoins ] = new SortedStringList();
				bvi = (char *) myAlloc(40);
				strcpy( bvi, bvLeft);
				joinedVar[noOfJoins]->insertSorted( STRCONS, VOID bvi);
				bvi = (char *) myAlloc(40);
				strcpy( bvi, bvRight );
				joinedVar[noOfJoins]->insertSorted( STRCONS, VOID bvi);

				// generate join args
				jarg = di->generateJoinPred();

				// generate plan
				currTree = (QUERY *) malloc( sizeof(QUERY) );
				currTree->my_operator = JOIN;
				currTree->argument.join = *jarg;
				myFree( (char *) jarg );

				// connect previously generated plan of left bind variable
				sbi = subTree->findPlace( bvLeft );
				currTree->input[0] = sbi->top;

				// connect previously generated plan of right bind variable
				sbi = subTree->findPlace( bvRight );
				currTree->input[1] = sbi->top;

				joinTree[noOfJoins] = currTree;

				// increment no of joins generated
				noOfJoins++;
				
			}
			// if both generated then
			else if( leftIndex == rightIndex )
			{
				errorType = 0;
				goto error_handler; 

				// generate plan
				currTree = (QUERY *) malloc( sizeof(QUERY) );
				currTree->my_operator = SELECT;
				currTree->argument.select.terms = 1;
				currTree->argument.select.cond[0] = di->generateJoinPred();
				currTree->input[0] = joinTree[ leftIndex ];
				currTree->input[1] = NULL;
				joinTree[ leftIndex ] = currTree;

/***************
				// add a AND to join argument
				jarg = ( JOIN_ARG * ) myAlloc( sizeof( JOIN_ARG ) );
				*jarg = joinTree[ leftIndex]->argument.join;

				// make old predicate as left now
				joinTree[ leftIndex ]->argument.join.left = jarg;


				// generate predicate
				jarg = di->generateJoinPred();


				// connect coming predicate to right
				joinTree[ leftIndex ]->argument.join.right = jarg;

				joinTree[ leftIndex ]->argument.join.type     = OPER;
				joinTree[ leftIndex ]->argument.join.fcn      = NULL;
				joinTree[ leftIndex ]->argument.join.data.op  = AND;

				// no increment no of joins
*****************/

			}
			// only one side is generated
			else if( leftIndex == MAXJOINNO + 1  && rightIndex < noOfJoins ) {
				// add bind variable to joinedVar
				bvi = (char *) myAlloc(40);
				strcpy( bvi, bvLeft );
				joinedVar[ rightIndex ]->insertSorted( STRCONS, VOID bvi );

				// generate join args
				jarg = di->generateJoinPred();

				// generate plan
				currTree = (QUERY *) malloc( sizeof(QUERY) );
				currTree->my_operator = JOIN;
				currTree->argument.join = *jarg;
				myFree( (char *) jarg );

				// connect previously generated plan of right bind variable
				sbi = subTree->findPlace( bvLeft );
				currTree->input[1] = sbi->top;

				// connect generated join tree
				currTree->input[0] = joinTree[ rightIndex ];
				joinTree[ rightIndex ] = currTree;

			}
			else if( rightIndex == MAXJOINNO + 1 && leftIndex < noOfJoins ) {
				// add bind variable to joinedVar
				bvi = (char *) myAlloc(40);
				strcpy( bvi, bvRight );
				joinedVar[ leftIndex ]->insertSorted( STRCONS, VOID bvi );

				// generate join args
				jarg = di->generateJoinPred();

				// generate plan
				currTree = (QUERY *) malloc( sizeof(QUERY) );
				currTree->my_operator = JOIN;
				currTree->argument.join = *jarg;
				myFree( ( char *) jarg );

				// connect previously generated plan of right bind variable
				sbi = subTree->findPlace( bvRight );
				currTree->input[1] = sbi->top;

				// connect generated join tree
				currTree->input[0] = joinTree[ leftIndex ];
				joinTree[ leftIndex ] = currTree;

			}
			else if( leftIndex < noOfJoins && rightIndex < noOfJoins )
			{
				// merge 
				joinedVar[ noOfJoins] = joinedVar[ leftIndex ]->merge( joinedVar[rightIndex] );
				// generate join args
				jarg = di->generateJoinPred();

				// generate plan
				currTree = (QUERY *) malloc( sizeof(QUERY) );
				currTree->my_operator = JOIN;
				currTree->argument.join = *jarg;
				myFree( (char *) jarg );

				joinTree[ noOfJoins ] = currTree;
				currTree->input[0] = joinTree[ leftIndex ];
				currTree->input[1] = joinTree[ rightIndex ];

				// increment no of joins
				noOfJoins++;
				

				// remove left & right
				delete joinedVar[ leftIndex ];
				delete joinedVar[ rightIndex ];

				// adjust jointree
				int minIndex= leftIndex, maxIndex = rightIndex;
				if( leftIndex > rightIndex ) {
					minIndex = rightIndex;
					maxIndex = leftIndex;
				}

				for( treeCnt = maxIndex; treeCnt < noOfJoins-1; treeCnt++ ) {
					joinTree[ treeCnt ] = joinTree[ treeCnt + 1   ];
					joinedVar[ treeCnt ] = joinedVar[ treeCnt + 1 ];
				}
				noOfJoins--;

				for( treeCnt = minIndex; treeCnt < noOfJoins-1; treeCnt++ ) {
					joinTree[ treeCnt ] = joinTree[ treeCnt + 1   ];
					joinedVar[ treeCnt ] = joinedVar[ treeCnt + 1 ];
				}
				noOfJoins--;

			}
		}

		p = p->next;
	}


	for( treeCnt = 0; treeCnt < noOfJoins; treeCnt++ )
	{
		checkCartesian = checkCartesian + joinedVar[ treeCnt ]->size;
		delete joinedVar[ treeCnt ];
	}

	if( ( noOfJoins == 0 && subTree->size > 1 ) ||
		 ( noOfJoins  > 0 && checkCartesian != subTree->size )) {
		errorType = 1;
		goto error_handler;
	}

	if( noOfJoins == 1 ) return joinTree[ 0 ];
	else if( noOfJoins == 0 ) return NULL;

error_handler :

	for( treeCnt = 0; treeCnt < noOfJoins; treeCnt++ ) {
		delete joinedVar[ treeCnt ];
		freeQUERY( joinTree[ treeCnt ] );
		joinedVar[ treeCnt ]  = NULL;
		joinTree [ treeCnt ] = NULL;
	}

	if( errorType == 0 )
		ur->setError( RUNTIME_ERROR, R_VERSION_ERROR, "cyclic join predicates" );
	else 
		ur->setError( RUNTIME_ERROR, R_VERSION_ERROR, "cartesian product" ); 
	return (QUERY *) &undefinedItem;
}


void PathExpression::generateMAT( SubTreeList *subTree )
// generate series of MAT operations here
{
#ifdef DEBUG
	printf(" PathExpression::generateMAT\n");
#endif
	ListItem	*currPI, *lastMATPI;
	char		pathStr[2*MAXSTRLEN];
	QUERY		*currTree;
	SubTreeItem	*place;

	subTree->printOn();

	if( pathItems->size == 1 ) return;
	
	currPI    = pathItems->firstItem;
	strcpy( pathStr, ((PathItem *) currPI->item)->itemSign );
	place = subTree->findPlace( pathStr );
	if( !place )
	{
		printf(" Impossible...cer ");
		exit(1);
	}

        lastMATPI = pathItems->lastItem;

	currPI    = currPI->next; // bypass bind variable

	while(  currPI && ( currPI != lastMATPI )  )
	{
		((PathItem *)currPI->item)->generateMAT( place, pathStr );
		currPI = currPI->next;
	}
}

void PathItem::generateMAT( SubTreeItem *place, char *pathStr )
// generate one MAT for PathItem
{
#ifdef DEBUG
	printf("PathItem::generateMAT\n");
#endif
	QUERY 	*outTree, *internalQuery;
	// Check PathItem is valid for MAT operation

	// Check this MAT previously generated or not
	if( dbType == 1 ) {
		if( *itemSign == '$' ) {
			strcat( pathStr, itemSign );
		}
		else {
			strcat(pathStr, ".");
			strcat( pathStr, itemSign );
		}
		return;
	} else {
		strcat(pathStr, ".");
		strcat( pathStr, itemSign );
	}

	internalQuery = place->isGeneratedMAT( pathStr );

	if( !internalQuery ) 
	{
		//outTree = new QUERY;
		outTree = (QUERY *) malloc( sizeof(QUERY) );
		outTree->my_operator = MAT;
		outTree->argument.mat.num = 1;
		outTree->argument.mat.ref_or_set[0] = isSetList;
		strcpy( outTree->argument.mat.attr[0], pathStr );
		((RELATION_SCHEMA)outTree->argument.mat.input[0]).copy(&attClass);
		outTree->input[0] = place->top;
		outTree->input[1] = NULL;
		place->top = outTree;
                outTree->argument.mat.fcn[0] = NULL;
		// if it is a function
		if( itemType == PATH_FUNCTION ) {

			FCN_INPUT	*fi;
			int		i;
			fi = ( FCN_INPUT * ) myAlloc( sizeof( FCN_INPUT ) );

			if( parameters ) {
				ListItem	*p;
				int		i;

				// Prepare argument list for evaluation
				for( p = parameters->firstItem, i=0; p; p=p->next, i++ )
					fi->ParExpr[i] = ( (Expression *) p->item)->
					  convertToIlker(((Expression *) p->item)->lastItem);
				
			}

			// set the number of argument
			if( parameters ) fi->argnum = parameters->size;
			else fi->argnum = 0;
			strcpy( fi->FcnName, itemName );
			fi->ret_type = returnType;
			strcpy( fi->ret_name, retTypeName );
			outTree->argument.mat.fcn[0] = fi ;
		}
	}
	else { // previously generated MAT
		copyFunctionAtt( &internalQuery->argument.mat.input[0], &attClass );

	}
}

char *PathExpression::findString()
// generate series of SELECT operations here
{
	ListItem	*p;
	p = pathItems->firstItem;
	strcpy(  pathExpAsString, ( (PathItem *) p->item)->itemSign );
	p = p->next;

	if(!p) strcat( pathExpAsString, ".self" );

	while(p)
	{
		if( *( (PathItem *) p->item)->itemSign != '$' )
			strcat( pathExpAsString, ".");
		strcat( pathExpAsString, ( (PathItem *) p->item)->itemSign );
		p = p->next;
	}
	return pathExpAsString;
}

void DictItem::generateSELECT( SubTreeList *subTree )
{
#ifdef DEBUG
	printf(" DictItem::generateSELECT\n");
#endif
	SubTreeItem	*place;
	ListItem	*p;
	if( key->size > 1 ) return;
	place = subTree->findPlace( ( char *) key->firstItem->item );
	if(!place)
	{
		printf("Imposible...2");
		exit(1);
	}
	p = exp->firstItem;
	while(p)
	{
		( (LinkedList *) p->item)->generateSELECT( place );
		p = p->next;
	}
}

void PathItem::convertParameters( FCN_INPUT **fin )
{
        if( itemType == PATH_FUNCTION ) {
 
                FCN_INPUT       *fi;
                int             i;
                *fin = fi = ( FCN_INPUT * ) myAlloc( sizeof( FCN_INPUT ) );
                fi->argnum = 0;
 
                if( parameters ) {
                        ListItem        *p;
                        int             i;
 
                        // Prepare argument list for evaluation
                        for( p = parameters->firstItem, i=0; p; p=p->next, i++ )
                                fi->ParExpr[i] = ( (Expression *) p->item)->
                                        convertToIlker(((Expression *) p->item)->lastItem);
			
                	fi->argnum = parameters->size;
 
                }
 
                // set the number of argument
                strcpy( fi->FcnName, itemName );
                fi->ret_type = returnType;
                strcpy( fi->ret_name, retTypeName );
        } 
}


void Dictionary::generateSELECT( SubTreeList *subTree )
{
#ifdef DEBUG
	printf(" Dictionary::generateSELECT\n");
#endif
	ListItem	*p;
	p = firstItem;
	while(p)
	{
		( ( DictItem *) p->item)->generateSELECT( subTree );
		p = p->next;
	}
}

JOIN_ARG * LinkedList::convertToIlker( ListItem *inItem )
{
#ifdef DEBUG
	printf("LinkedList::convertToIlker\n"); 
#endif

	JOIN_ARG	*ja;

        if(!this) return NULL;
	switch( inItem->itemType )
	{

		/* Logical Operators */
		case EQ : 
		case GT :
		case GE : 
		case LT : 
		case LE : 
		case NE :
		/* arithmetic operators */
		case ADD : 
		case SUB : 
		case MUL : 
		case DIV : 
		case MOD : 
			//ja = new JOIN_ARG;
			ja = (JOIN_ARG *) myAlloc( sizeof( JOIN_ARG ) );
			ja->fcn = NULL;
			ja->type  = OPER; 
			ja->data.op = inItem->itemType;
			ja->left  = convertToIlker( inItem->left );
			ja->right = convertToIlker( inItem->right );
			return ja;
		
		case PATH_EXP :
		{
			PathExpression	*pexp;
			pexp = (PathExpression *)inItem->item;
			//ja = new JOIN_ARG;
			ja = (JOIN_ARG *) myAlloc( sizeof( JOIN_ARG ) );
			ja->fcn = NULL;
			ja->left = NULL;
			ja->right = NULL;
			ja->type = ATTRIB;
			strcpy( ja->data.attr,pexp->findString());

			// if the last path item is  a function, process its parameters
			( (PathItem *) pexp->pathItems->lastItem->item)->
					convertParameters( &ja->fcn );
			return ja;
		}


		/* unary operators 
		case UNARYPLUS  : printf(" U+ "); break;
		case UNARYMINUS : printf(" U- "); break; */

		/* constants */
		case CHRCONS :
		case STRCONS : 
			//ja = new JOIN_ARG;
			ja = (JOIN_ARG *) myAlloc( sizeof( JOIN_ARG ) );
			ja->fcn = NULL;
			ja->left = NULL;
			ja->right = NULL;
			ja->type = CONST;
			ja->data.cnst.kind = TEXT;
			strcpy( ja->data.cnst.value.text_value, (char *) inItem->item);
			return ja;
		case UNSIGNEDREAL:
			//ja = new JOIN_ARG;
			ja = (JOIN_ARG *) myAlloc( sizeof( JOIN_ARG ) );
			ja->fcn = NULL;
			ja->left = NULL;
			ja->right = NULL;
			ja->type = CONST;
			ja->data.cnst.kind = REAL;
			ja->data.cnst.value.real_value = *((float *) inItem->item );
			return ja;

		case UNSIGNEDINT :
			//ja = new JOIN_ARG;
			ja = (JOIN_ARG *) myAlloc( sizeof( JOIN_ARG ) );
			ja->fcn = NULL;
			ja->left = NULL;
			ja->right = NULL;
			ja->type = CONST;
			ja->data.cnst.kind = INTEGER;
			ja->data.cnst.value.int_value = *((int *) inItem->item );
			return ja;

		case MS_TRUE :
		case MS_FALSE :
			ja = (JOIN_ARG *) myAlloc( sizeof( JOIN_ARG ) );
                        ja->fcn = NULL;
                        ja->left = NULL;
                        ja->right = NULL;
                        ja->type = CONST;
                        ja->data.cnst.kind = INTEGER;
			if( inItem->itemType == MS_TRUE )	 
                        	ja->data.cnst.value.int_value = 1;
			else
                        	ja->data.cnst.value.int_value = 0;
                        return ja;

		case NULLVALUE :
			printf( "Null Value not supported now\n" );
			break;
	
		default : 
			 printf(" Impossible in conversion : %d", inItem->itemType ); exit(1);
	}
	return NULL;
}

void LinkedList::generateSELECT( SubTreeItem *place )
{
#ifdef DEBUG
	printf(" LinkedList::generateSELECT \n");
#endif
	QUERY	*currTree;
	//currTree	= new QUERY;
	currTree = (QUERY *) malloc( sizeof(QUERY) );
	currTree->my_operator = SELECT;
	currTree->argument.select.terms = 1;
	currTree->argument.select.cond[0] = convertToIlker( lastItem );
	currTree->input[0] = place->top;
	currTree->input[1] = NULL;
	place->top = currTree;
#ifdef DEBUG
	printPlan( place->top );
#endif
}

void LinkedList::generateMAT( SubTreeList *subTree)
{
#ifdef DEBUG
	printf("void LinkedList::generateMAT\n"); 
#endif
	ListItem	*p = firstItem;
	while(p)
	{
		if( p->itemType == PATH_EXP)
			( ( PathExpression *) p->item)->generateMAT( subTree );
		p = p->next;
	}

}


Expression::findUseSelves( SortedStringList *useSelfList )
{
	ListItem *p;
	p = firstItem;
	PathExpression  *pexp;
	PathItem	*pi;
	while(p)
	{
		if( p->itemType == PATH_EXP ) 
		{
			pexp = ( PathExpression * ) p->item;
			if( pexp->pathItems->size == 1 )
			{
				char *anItemName;
				anItemName = (char *) myAlloc(80);
				pi = (PathItem *) pexp->pathItems->firstItem->item;
				strcpy( anItemName, pi->itemName);
			        useSelfList->insertSorted( STRCONS,anItemName ); 
#ifdef DEBUG
				printf(" %s\n", VOID anItemName );
#endif
			}
		}
		p = p->next;
	}
	return TRUE;
}


Query::generateTreeForNoPredicate()
{
	SortedStringList	*aList;

	if( bindList->size >= 2 )
	{
		setError( PARSE_ERROR, VERSION_ERR, " cartesian product (missing where predicate ) ");
		return FALSE;
	}
	if( !checkSemantic() ) return FALSE;

	aList = new SortedStringList();

	if( projectionList )
	{
		ListItem *p;
		p = projectionList->firstItem;
		while(p)
		{
		        ( (ProjectionListItem *) p->item)->projExpression->
				findUseSelves( aList );
	
			p = p->next;
		} 
	}

	SubTreeList     *subTree = new SubTreeList();
 
        // generates GET_SET 
        subTree->generate( bindList, aList );

	// now generate MAT for projectionList
	ListItem *p = projectionList->firstItem;
	while(p)
	{
		( (ProjectionListItem *) p->item)->projExpression->
			generateMAT( subTree );
		p = p->next;
	}
        queryTree = ( ( SubTreeItem *) subTree->firstItem->item)->top;
	delete subTree;
	return TRUE;
}


Query::generateTree()
{
	SubTreeList	 *subTree;
	SortedStringList *aList;
#ifdef DEBUG
	printf(" Query::generateTree\n");
#endif
	// Check the semantic of the query
	if( !checkSemantic() ) return FALSE;

	// normalize query : convert into disjunctive normal form
	// divide where predicate
	normalizeQuery();

	// find the variables that needs self attribute
	aList = new SortedStringList();
        subTree = new SubTreeList();
	whereP->findUseSelves( aList );
	if( projectionList ) {
		ListItem *p;
		for( p = projectionList->firstItem; p; p=p->next )
		        ( (ProjectionListItem *) p->item)->projExpression->
				findUseSelves( aList );
	}

	// if query is semantically correct and normalized then generate tree
	// generates GET_SET 
	subTree->generate( bindList, aList );

	// genarates JOIN & MAT
	queryTree = ORTerms->generateTree( subTree, projectionList, ur );
	if( queryTree == (QUERY *) &undefinedItem ) {
		delete subTree;
		return FALSE;
	}

	// That's all folks, delete subTree
	delete subTree;
	// delete useSelfVariables;

	return TRUE;
}


JOIN_ARG** ProjectionExpression::convertToMehmet()
{
	JOIN_ARG	**outPList;
	Expression	*anExp;
	int		i=0;
	ListItem	*p = firstItem;
	outPList = ( JOIN_ARG **) myAlloc( (size+1) * sizeof( JOIN_ARG *) );
	outPList[size] = NULL;
	while( p )
	{
		anExp = ((ProjectionListItem *) p->item)->projExpression;
		outPList[i] = anExp->convertToIlker(anExp->lastItem );
		i++;
		p = p->next;
	}
	return outPList;
}
		
	
